/**
 * Funkwhale API
 * 1.2.8
 * DO NOT MODIFY - This file has been generated using oazapfts.
 * See https://www.npmjs.com/package/oazapfts
 */
import * as Oazapfts from "oazapfts/lib/runtime";
import * as QS from "oazapfts/lib/runtime/query";
export const defaults: Oazapfts.RequestOpts = {
    baseUrl: "https://demo.funkwhale.audio",
};
const oazapfts = Oazapfts.runtime(defaults);
export const servers = {
    demoServer: "https://demo.funkwhale.audio",
    readServerWithRealContent: "https://funkwhale.audio",
    customServer: ({ domain = "yourdomain", protocol = "https" }: {
        domain: string | number | boolean;
        protocol: "http" | "https";
    }) => `${protocol}://${domain}`
};
export type ContentCategoryEnum = "music" | "podcast" | "other";
export type ContentTypeEnum = "text/html" | "text/markdown" | "text/plain";
export type Content = {
    text: string | null;
    content_type: ContentTypeEnum;
    html: string;
};
export type CoverField = {
    uuid: string;
    size: number;
    mimetype: string;
    creation_date: string;
    urls: {
        [key: string]: any;
    };
};
export type SimpleArtist = {
    id: number;
    fid?: string | null;
    mbid?: string | null;
    name: string;
    creation_date?: string;
    modification_date?: string;
    is_local: boolean;
    content_category?: ContentCategoryEnum;
    description?: (Content) | null;
    attachment_cover?: (CoverField) | null;
    channel?: string | null;
};
export type FederationChoiceEnum = "Person" | "Tombstone" | "Application" | "Group" | "Organization" | "Service";
export type ApiActor = {
    fid: string;
    url?: string | null;
    creation_date?: string;
    summary?: string | null;
    preferred_username: string | null;
    name?: string | null;
    last_fetch_date?: string;
    domain: string;
    "type"?: FederationChoiceEnum;
    manually_approves_followers?: boolean | null;
    full_username: string;
    is_local: boolean;
};
export type Album = {
    artist: SimpleArtist;
    cover: (CoverField) | null;
    is_playable: boolean;
    tags: string[];
    tracks_count: number;
    attributed_to: ApiActor;
    id: number;
    fid: string;
    mbid: string;
    title: string;
    release_date: string;
    creation_date: string;
    is_local: boolean;
    duration: number;
};
export type PaginatedAlbumList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Album[];
};
export type ContentRequest = {
    text: string | null;
    content_type: ContentTypeEnum;
};
export type AlbumCreateRequest = {
    cover?: string | null;
    title: string;
    release_date?: string | null;
    tags?: string[];
    description?: (ContentRequest) | null;
    artist: string;
};
export type AlbumCreate = {
    title: string;
    release_date?: string | null;
    tags?: string[];
    description?: (Content) | null;
    artist: string;
};
export type FetchStatusEnum = "pending" | "errored" | "finished" | "skipped";
export type Fetch = {
    id: number;
    url: string;
    actor: ApiActor;
    status: FetchStatusEnum;
    detail: {
        [key: string]: any;
    };
    creation_date: string;
    fetch_date: string | null;
};
export type PaginatedFetchList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Fetch[];
};
export type CoverFieldRequest = {
    file: Blob;
};
export type SimpleArtistRequest = {
    fid?: string | null;
    mbid?: string | null;
    name: string;
    creation_date?: string;
    modification_date?: string;
    content_category?: ContentCategoryEnum;
    description?: (ContentRequest) | null;
    attachment_cover?: (CoverFieldRequest) | null;
    channel?: string | null;
};
export type ApiActorRequest = {
    fid: string;
    url?: string | null;
    creation_date?: string;
    summary?: string | null;
    preferred_username: string | null;
    name?: string | null;
    last_fetch_date?: string;
    domain: string;
    "type"?: FederationChoiceEnum;
    manually_approves_followers?: boolean | null;
};
export type AlbumRequest = {
    artist: SimpleArtistRequest;
    cover: (CoverFieldRequest) | null;
    attributed_to: ApiActorRequest;
    id: number;
    fid: string;
    mbid: string;
    title: string;
    release_date: string;
    creation_date: string;
    is_local: boolean;
};
export type LibraryPrivacyLevelEnum = "me" | "instance" | "everyone";
export type NestedLibraryFollow = {
    creation_date?: string;
    uuid?: string;
    fid?: string | null;
    approved?: boolean | null;
    modification_date: string;
};
export type LibraryScan = {
    total_files?: number;
    processed_files?: number;
    errored_files?: number;
    status?: string;
    creation_date?: string;
    modification_date?: string | null;
};
export type Library = {
    fid: string;
    uuid?: string;
    actor: ApiActor;
    name: string;
    description?: string | null;
    creation_date?: string;
    uploads_count: number;
    privacy_level?: LibraryPrivacyLevelEnum;
    follow?: (NestedLibraryFollow) | null;
    latest_scan?: (LibraryScan) | null;
};
export type PaginatedLibraryList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Library[];
};
export type ApiMutation = {
    fid: string;
    uuid: string;
    "type": string;
    creation_date: string;
    applied_date?: string | null;
    is_approved?: boolean | null;
    is_applied: boolean | null;
    created_by: ApiActor;
    approved_by: number | null;
    summary?: string | null;
    payload: {
        [key: string]: any;
    };
    previous_state: {
        [key: string]: any;
    } | null;
    target: {
        [key: string]: any;
    };
};
export type PaginatedApiMutationList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ApiMutation[];
};
export type ArtistAlbum = {
    tracks_count: number;
    cover: (CoverField) | null;
    is_playable: boolean;
    is_local: boolean;
    id: number;
    fid: string;
    mbid: string;
    title: string;
    artist: number;
    release_date: string;
    creation_date: string;
};
export type InlineActor = {
    full_username: string;
    preferred_username: string;
    domain: string;
};
export type ArtistWithAlbumsInlineChannel = {
    uuid: string;
    actor: InlineActor;
};
export type ArtistWithAlbums = {
    albums: ArtistAlbum[];
    tags: string[];
    attributed_to: (ApiActor) | null;
    channel: (ArtistWithAlbumsInlineChannel) | null;
    tracks_count: number;
    id: number;
    fid: string;
    mbid: string;
    name: string;
    content_category: string;
    creation_date: string;
    is_local: boolean;
    cover: (CoverField) | null;
};
export type PaginatedArtistWithAlbumsList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ArtistWithAlbums[];
};
export type ArtistAlbumRequest = {
    cover: (CoverFieldRequest) | null;
    is_local: boolean;
    id: number;
    fid: string;
    mbid: string;
    title: string;
    release_date: string;
    creation_date: string;
};
export type InlineActorRequest = {
    full_username: string;
    preferred_username: string;
    domain: string;
};
export type ArtistWithAlbumsInlineChannelRequest = {
    uuid: string;
    actor: InlineActorRequest;
};
export type ArtistWithAlbumsRequest = {
    albums: ArtistAlbumRequest[];
    attributed_to: (ApiActorRequest) | null;
    channel: (ArtistWithAlbumsInlineChannelRequest) | null;
    id: number;
    fid: string;
    mbid: string;
    name: string;
    content_category: string;
    creation_date: string;
    is_local: boolean;
    cover: (CoverFieldRequest) | null;
};
export type AttachmentRequest = {
    file: Blob;
};
export type Attachment = {
    uuid: string;
    size: number;
    mimetype: string;
    creation_date: string;
    urls: {
        [key: string]: any;
    };
};
export type PasswordChangeRequest = {
    old_password: string;
    new_password1: string;
    new_password2: string;
};
export type PasswordChange = {
    old_password: string;
    new_password1: string;
    new_password2: string;
};
export type PasswordResetRequest = {
    email: string;
};
export type PasswordReset = {
    email: string;
};
export type PasswordResetConfirmRequest = {
    new_password1: string;
    new_password2: string;
    uid: string;
    token: string;
};
export type PasswordResetConfirm = {
    new_password1: string;
    new_password2: string;
    uid: string;
    token: string;
};
export type RegisterRequest = {
    username: string;
    email: string;
    password1: string;
    password2: string;
    invitation?: string | null;
};
export type Register = {
    username: string;
    email: string;
    invitation?: string | null;
};
export type VerifyEmailRequest = {
    key: string;
};
export type VerifyEmail = {
    key: string;
};
export type UserDetails = {
    pk: number;
    username: string;
    email: string;
    first_name?: string;
    last_name?: string;
};
export type UserDetailsRequest = {
    username: string;
    first_name?: string;
    last_name?: string;
};
export type PatchedUserDetailsRequest = {
    username?: string;
    first_name?: string;
    last_name?: string;
};
export type Channel = {
    uuid?: string;
    artist: SimpleArtist;
    attributed_to: ApiActor;
    actor: ApiActor;
    creation_date?: string;
    metadata?: {
        [key: string]: any;
    };
    rss_url: string;
    url: string;
    downloads_count: number;
};
export type PaginatedChannelList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Channel[];
};
export type ChannelCreateRequest = {
    cover?: string | null;
    name: string;
    username: string;
    description: (ContentRequest) | null;
    tags: string[];
    content_category: ContentCategoryEnum;
    metadata?: {
        [key: string]: any;
    };
};
export type ChannelCreate = {
    name: string;
    username: string;
    description: (Content) | null;
    tags: string[];
    content_category: ContentCategoryEnum;
    metadata?: {
        [key: string]: any;
    };
};
export type ChannelUpdateRequest = {
    cover?: string | null;
    name: string;
    description: (ContentRequest) | null;
    tags: string[];
    content_category: ContentCategoryEnum;
    metadata?: {
        [key: string]: any;
    };
};
export type ChannelUpdate = {
    name: string;
    description: (Content) | null;
    tags: string[];
    content_category: ContentCategoryEnum;
    metadata?: {
        [key: string]: any;
    };
};
export type PatchedChannelUpdateRequest = {
    cover?: string | null;
    name?: string;
    description?: (ContentRequest) | null;
    tags?: string[];
    content_category?: ContentCategoryEnum;
    metadata?: {
        [key: string]: any;
    };
};
export type ChannelRequest = {
    uuid?: string;
    artist: SimpleArtistRequest;
    attributed_to: ApiActorRequest;
    creation_date?: string;
    metadata?: {
        [key: string]: any;
    };
    rss_url: string;
};
export type UserBasic = {
    id: number;
    username: string;
    name?: string;
    date_joined?: string;
    avatar: (Attachment) | null;
};
export type TrackAlbum = {
    id: number;
    fid?: string | null;
    mbid?: string | null;
    title: string;
    artist: SimpleArtist;
    release_date?: string | null;
    cover: (CoverField) | null;
    creation_date?: string;
    is_local: boolean;
    tracks_count: number;
};
export type Track = {
    artist: SimpleArtist;
    album: TrackAlbum;
    uploads: object[];
    listen_url: string;
    tags: string[];
    attributed_to: (ApiActor) | null;
    id: number;
    fid: string;
    mbid: string;
    title: string;
    creation_date: string;
    is_local: boolean;
    position: number;
    disc_number: number;
    downloads_count: number;
    copyright: string;
    license: string;
    cover: (CoverField) | null;
    is_playable: boolean;
};
export type UserTrackFavorite = {
    id: number;
    user: UserBasic;
    track: Track;
    creation_date?: string;
    actor: ApiActor;
};
export type PaginatedUserTrackFavoriteList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: UserTrackFavorite[];
};
export type UserTrackFavoriteWriteRequest = {
    track: number;
    creation_date?: string;
};
export type UserTrackFavoriteWrite = {
    id: number;
    track: number;
    creation_date?: string;
};
export type SimpleFavorite = {
    id: number;
    track: number;
};
export type AllFavorite = {
    results: SimpleFavorite[];
    count: number;
};
export type FullActor = {
    fid: string;
    url: string;
    domain: string;
    creation_date: string;
    last_fetch_date: string;
    name: string;
    preferred_username: string;
    full_username: string;
    "type": string;
    is_local: boolean;
    is_channel: boolean;
    manually_approves_followers: boolean;
    user: UserBasic;
    summary: Content;
    icon: Attachment;
};
export type LibraryForOwner = {
    uuid: string;
    fid: string;
    name: string;
    description?: string | null;
    privacy_level?: LibraryPrivacyLevelEnum;
    uploads_count: number;
    size: number;
    creation_date: string;
    actor: ApiActor;
};
export type Domain = {
    name: string;
};
export type PaginatedDomainList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Domain[];
};
export type FetchRequest = {
    "object": string;
    force?: boolean;
};
export type LibraryFollow = {
    creation_date: string;
    actor: ApiActor;
    uuid: string;
    target: string;
    approved: boolean | null;
};
export type PaginatedLibraryFollowList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: LibraryFollow[];
};
export type LibraryFollowRequest = {
    target: string;
};
export type InboxItemTypeEnum = "to" | "cc";
export type Activity = {
    uuid?: string;
    fid?: string | null;
    actor: ApiActor;
    payload?: {
        [key: string]: any;
    };
    "object": {
        [key: string]: any;
    } | null;
    target: {
        [key: string]: any;
    } | null;
    related_object: {
        [key: string]: any;
    };
    creation_date?: string;
    "type"?: string | null;
};
export type InboxItem = {
    id: number;
    "type": InboxItemTypeEnum;
    activity: Activity;
    is_read?: boolean;
};
export type PaginatedInboxItemList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: InboxItem[];
};
export type ActivityRequest = {
    uuid?: string;
    fid?: string | null;
    actor: ApiActorRequest;
    payload?: {
        [key: string]: any;
    };
    creation_date?: string;
    "type"?: string | null;
};
export type InboxItemRequest = {
    activity: ActivityRequest;
    is_read?: boolean;
};
export type PatchedInboxItemRequest = {
    activity?: ActivityRequest;
    is_read?: boolean;
};
export type NestedLibraryFollowRequest = {
    creation_date?: string;
    uuid?: string;
    fid?: string | null;
    approved?: boolean | null;
};
export type LibraryScanRequest = {
    total_files?: number;
    processed_files?: number;
    errored_files?: number;
    status?: string;
    creation_date?: string;
    modification_date?: string | null;
};
export type LibraryRequest = {
    fid: string;
    uuid?: string;
    actor: ApiActorRequest;
    name: string;
    description?: string | null;
    creation_date?: string;
    privacy_level?: LibraryPrivacyLevelEnum;
    follow?: (NestedLibraryFollowRequest) | null;
    latest_scan?: (LibraryScanRequest) | null;
};
export type Listening = {
    id: number;
    user: UserBasic;
    track: Track;
    creation_date?: string | null;
    actor: ApiActor;
};
export type PaginatedListeningList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Listening[];
};
export type ListeningWriteRequest = {
    user?: number | null;
    track: number;
    creation_date?: string | null;
};
export type ListeningWrite = {
    id: number;
    user?: number | null;
    track: number;
    creation_date?: string | null;
};
export type GlobalPreference = {
    section: string;
    name: string;
    identifier: string;
    "default": string;
    value: string;
    verbose_name: string;
    help_text: string;
    additional_data: string;
    field: string;
};
export type GlobalPreferenceRequest = {
    value: string;
};
export type PatchedGlobalPreferenceRequest = {
    value?: string;
};
export type Software = {
    name: string;
    version: string;
};
export type Services = {
    inbound?: string[];
    outbound?: string[];
};
export type UsersUsage = {
    total: number;
    activeHalfyear: number;
    activeMonth: number;
};
export type Usage = {
    users: UsersUsage;
};
export type TotalCount = {
    total: number;
};
export type TotalHours = {
    hours: number;
};
export type NodeInfoLibrary = {
    federationEnabled: boolean;
    anonymousCanListen: boolean;
    tracks?: TotalCount;
    artists?: TotalCount;
    albums?: TotalCount;
    music?: TotalHours;
};
export type AllowListStat = {
    enabled: boolean;
    domains: string[];
};
export type ReportType = {
    "type": string;
    label: string;
    anonymous: boolean;
};
export type Endpoints = {
    knownNodes?: string;
    channels?: string;
    libraries?: string;
};
export type MetadataUsageFavorite = {
    tracks: TotalCount;
};
export type MetadataUsage = {
    favorites: MetadataUsageFavorite;
    listenings: TotalCount;
    downloads: TotalCount;
};
export type Metadata = {
    actorId: string;
    "private": boolean;
    shortDescription: string;
    longDescription: string;
    rules: string;
    contactEmail: string;
    terms: string;
    nodeName: string;
    banner: string;
    defaultUploadQuota: number;
    library: NodeInfoLibrary;
    supportedUploadExtensions: string[];
    allowList: AllowListStat;
    reportTypes: ReportType[];
    funkwhaleSupportMessageEnabled: boolean;
    instanceSupportMessage: string;
    endpoints: Endpoints;
    usage?: MetadataUsage;
};
export type NodeInfo20 = {
    version: string;
    software: Software;
    protocols: any[];
    services?: Services;
    openRegistrations: boolean;
    usage: Usage;
    metadata: Metadata;
};
export type PaginatedLibraryForOwnerList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: LibraryForOwner[];
};
export type LibraryForOwnerRequest = {
    name: string;
    description?: string | null;
    privacy_level?: LibraryPrivacyLevelEnum;
};
export type PatchedLibraryForOwnerRequest = {
    name?: string;
    description?: string | null;
    privacy_level?: LibraryPrivacyLevelEnum;
};
export type License = {
    id: string;
    url: string;
    code: string;
    name: string;
    redistribute: boolean;
    derivative: boolean;
    commercial: boolean;
    attribution: boolean;
    copyleft: boolean;
};
export type PaginatedLicenseList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: License[];
};
export type PrivacyLevelEnum = "me" | "followers" | "instance" | "everyone";
export type ManageUser = {
    id: number;
    username: string;
    actor: {
        [key: string]: any;
    };
    email: string;
    name?: string;
    is_active?: boolean;
    is_staff?: boolean;
    is_superuser?: boolean;
    date_joined: string;
    last_activity: string | null;
    privacy_level: PrivacyLevelEnum;
    upload_quota?: number | null;
    full_username: string;
};
export type ManageActor = {
    id: number;
    url?: string | null;
    fid: string;
    preferred_username: string | null;
    full_username: string;
    domain: string;
    name?: string | null;
    summary?: string | null;
    "type"?: FederationChoiceEnum;
    creation_date: string;
    last_fetch_date?: string;
    inbox_url?: string | null;
    outbox_url?: string | null;
    shared_inbox_url?: string | null;
    manually_approves_followers?: boolean | null;
    is_local: boolean;
    uploads_count: number;
    user: (ManageUser) | null;
    instance_policy: number;
};
export type PaginatedManageActorList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageActor[];
};
export type ManageUserRequest = {
    name?: string;
    is_active?: boolean;
    is_staff?: boolean;
    is_superuser?: boolean;
    upload_quota?: number | null;
};
export type ManageActorRequest = {
    url?: string | null;
    fid: string;
    preferred_username: string | null;
    domain: string;
    name?: string | null;
    summary?: string | null;
    "type"?: FederationChoiceEnum;
    last_fetch_date?: string;
    inbox_url?: string | null;
    outbox_url?: string | null;
    shared_inbox_url?: string | null;
    manually_approves_followers?: boolean | null;
    user: (ManageUserRequest) | null;
};
export type ManageBaseActor = {
    id: number;
    url?: string | null;
    fid: string;
    preferred_username: string | null;
    full_username: string;
    domain: string;
    name?: string | null;
    summary?: string | null;
    "type"?: FederationChoiceEnum;
    creation_date: string;
    last_fetch_date?: string;
    inbox_url?: string | null;
    outbox_url?: string | null;
    shared_inbox_url?: string | null;
    manually_approves_followers?: boolean | null;
    is_local: boolean;
};
export type ManageArtist = {
    id: number;
    fid?: string | null;
    mbid?: string | null;
    name: string;
    creation_date?: string;
    domain: string;
    is_local: boolean;
    tracks_count: number;
    albums_count: number;
    attributed_to: ManageBaseActor;
    tags: string[];
    cover: (CoverField) | null;
    channel: string;
    content_category?: ContentCategoryEnum;
};
export type ManageChannel = {
    id: number;
    uuid: string;
    creation_date: string;
    artist: ManageArtist;
    attributed_to: ManageBaseActor;
    actor: ManageBaseActor;
    rss_url: string | null;
    metadata: {
        [key: string]: any;
    };
};
export type PaginatedManageChannelList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageChannel[];
};
export type ManageDomain = {
    name: string;
    creation_date: string;
    actors_count: number;
    outbox_activities_count: number;
    nodeinfo: {
        [key: string]: any;
    };
    nodeinfo_fetch_date: string | null;
    instance_policy: number;
    allowed?: boolean | null;
};
export type PaginatedManageDomainList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageDomain[];
};
export type ManageDomainRequest = {
    name: string;
    allowed?: boolean | null;
};
export type ManageDomainUpdateRequest = {
    allowed?: boolean | null;
};
export type ManageDomainUpdate = {
    name: string;
    creation_date: string;
    actors_count: number;
    outbox_activities_count: number;
    nodeinfo: {
        [key: string]: any;
    };
    nodeinfo_fetch_date: string | null;
    instance_policy: number;
    allowed?: boolean | null;
};
export type PatchedManageDomainUpdateRequest = {
    allowed?: boolean | null;
};
export type ManageNestedArtist = {
    id: number;
    fid?: string | null;
    mbid?: string | null;
    name: string;
    creation_date?: string;
    domain: string;
    is_local: boolean;
};
export type ManageAlbum = {
    id: number;
    fid?: string | null;
    mbid?: string | null;
    title: string;
    creation_date?: string;
    release_date?: string | null;
    cover: CoverField;
    domain: string;
    is_local: boolean;
    tracks_count: number;
    artist: ManageNestedArtist;
    attributed_to: ManageBaseActor;
    tags: string[];
};
export type PaginatedManageAlbumList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageAlbum[];
};
export type ManageNestedArtistRequest = {
    fid?: string | null;
    mbid?: string | null;
    name: string;
    creation_date?: string;
    domain: string;
};
export type ManageBaseActorRequest = {
    url?: string | null;
    fid: string;
    preferred_username: string | null;
    domain: string;
    name?: string | null;
    summary?: string | null;
    "type"?: FederationChoiceEnum;
    last_fetch_date?: string;
    inbox_url?: string | null;
    outbox_url?: string | null;
    shared_inbox_url?: string | null;
    manually_approves_followers?: boolean | null;
};
export type ManageAlbumRequest = {
    fid?: string | null;
    mbid?: string | null;
    title: string;
    creation_date?: string;
    release_date?: string | null;
    cover: CoverFieldRequest;
    domain: string;
    artist: ManageNestedArtistRequest;
    attributed_to: ManageBaseActorRequest;
};
export type PaginatedManageArtistList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageArtist[];
};
export type ManageArtistRequest = {
    fid?: string | null;
    mbid?: string | null;
    name: string;
    creation_date?: string;
    domain: string;
    attributed_to: ManageBaseActorRequest;
    cover: (CoverFieldRequest) | null;
    content_category?: ContentCategoryEnum;
};
export type ManageLibrary = {
    id: number;
    uuid: string;
    fid: string;
    url: string | null;
    name: string;
    description?: string | null;
    domain: string;
    is_local: boolean;
    creation_date: string;
    privacy_level?: LibraryPrivacyLevelEnum;
    uploads_count: number;
    followers_count: number;
    followers_url: string;
    actor: ManageBaseActor;
};
export type PaginatedManageLibraryList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageLibrary[];
};
export type ManageLibraryRequest = {
    name: string;
    description?: string | null;
    domain: string;
    privacy_level?: LibraryPrivacyLevelEnum;
    followers_url: string;
    actor: ManageBaseActorRequest;
};
export type PatchedManageLibraryRequest = {
    name?: string;
    description?: string | null;
    domain?: string;
    privacy_level?: LibraryPrivacyLevelEnum;
    followers_url?: string;
    actor?: ManageBaseActorRequest;
};
export type ManageTrackAlbum = {
    id: number;
    fid?: string | null;
    mbid?: string | null;
    title: string;
    creation_date?: string;
    release_date?: string | null;
    cover: CoverField;
    domain: string;
    is_local: boolean;
    tracks_count: number;
    artist: ManageNestedArtist;
};
export type ManageTrack = {
    id: number;
    fid?: string | null;
    mbid?: string | null;
    title: string;
    creation_date?: string;
    position?: number | null;
    disc_number?: number | null;
    domain: string;
    is_local: boolean;
    copyright?: string | null;
    license?: string | null;
    artist: ManageNestedArtist;
    album: (ManageTrackAlbum) | null;
    attributed_to: (ManageBaseActor) | null;
    uploads_count: number;
    tags: string[];
    cover: CoverField;
};
export type PaginatedManageTrackList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageTrack[];
};
export type ManageTrackAlbumRequest = {
    fid?: string | null;
    mbid?: string | null;
    title: string;
    creation_date?: string;
    release_date?: string | null;
    cover: CoverFieldRequest;
    domain: string;
    artist: ManageNestedArtistRequest;
};
export type ManageTrackRequest = {
    fid?: string | null;
    mbid?: string | null;
    title: string;
    creation_date?: string;
    position?: number | null;
    disc_number?: number | null;
    domain: string;
    copyright?: string | null;
    license?: string | null;
    artist: ManageNestedArtistRequest;
    album: (ManageTrackAlbumRequest) | null;
    attributed_to: (ManageBaseActorRequest) | null;
    cover: CoverFieldRequest;
};
export type ImportStatusEnum = "draft" | "pending" | "finished" | "errored" | "skipped";
export type ManageNestedTrack = {
    id: number;
    fid?: string | null;
    mbid?: string | null;
    title: string;
    creation_date?: string;
    position?: number | null;
    disc_number?: number | null;
    domain: string;
    is_local: boolean;
    copyright?: string | null;
    license?: string | null;
};
export type ManageNestedLibrary = {
    id: number;
    uuid?: string;
    fid: string;
    url?: string | null;
    name: string;
    description?: string | null;
    domain: string;
    is_local: boolean;
    creation_date?: string;
    privacy_level?: LibraryPrivacyLevelEnum;
    followers_url: string;
    actor: ManageBaseActor;
};
export type ManageUpload = {
    id: number;
    uuid?: string;
    fid?: string | null;
    domain: string;
    is_local: boolean;
    audio_file: string;
    listen_url: string;
    source?: string | null;
    filename: string;
    mimetype?: string | null;
    duration?: number | null;
    bitrate?: number | null;
    size?: number | null;
    creation_date?: string;
    accessed_date?: string | null;
    modification_date?: string | null;
    metadata?: {
        [key: string]: any;
    };
    import_date?: string | null;
    import_details?: {
        [key: string]: any;
    };
    import_status?: ImportStatusEnum;
    import_metadata?: {
        [key: string]: any;
    };
    import_reference?: string;
    track: ManageNestedTrack;
    library: ManageNestedLibrary;
};
export type PaginatedManageUploadList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageUpload[];
};
export type ManageNestedTrackRequest = {
    fid?: string | null;
    mbid?: string | null;
    title: string;
    creation_date?: string;
    position?: number | null;
    disc_number?: number | null;
    domain: string;
    copyright?: string | null;
    license?: string | null;
};
export type ManageNestedLibraryRequest = {
    uuid?: string;
    fid: string;
    url?: string | null;
    name: string;
    description?: string | null;
    domain: string;
    creation_date?: string;
    privacy_level?: LibraryPrivacyLevelEnum;
    followers_url: string;
    actor: ManageBaseActorRequest;
};
export type ManageUploadRequest = {
    uuid?: string;
    fid?: string | null;
    domain: string;
    audio_file: Blob;
    source?: string | null;
    mimetype?: string | null;
    duration?: number | null;
    bitrate?: number | null;
    size?: number | null;
    creation_date?: string;
    accessed_date?: string | null;
    modification_date?: string | null;
    metadata?: {
        [key: string]: any;
    };
    import_date?: string | null;
    import_details?: {
        [key: string]: any;
    };
    import_status?: ImportStatusEnum;
    import_metadata?: {
        [key: string]: any;
    };
    import_reference?: string;
    track: ManageNestedTrackRequest;
    library: ManageNestedLibraryRequest;
};
export type ManageTargetTypeEnum = "domain" | "actor";
export type ManageTarget = {
    "type": ManageTargetTypeEnum;
    id: string;
};
export type ManageInstancePolicy = {
    id: number;
    uuid: string;
    target: ManageTarget;
    creation_date: string;
    actor: string;
    summary?: string | null;
    is_active?: boolean;
    block_all?: boolean;
    silence_activity?: boolean;
    silence_notifications?: boolean;
    reject_media?: boolean;
};
export type PaginatedManageInstancePolicyList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageInstancePolicy[];
};
export type ManageTargetRequest = {
    "type": ManageTargetTypeEnum;
    id: string;
};
export type ManageInstancePolicyRequest = {
    target: ManageTargetRequest;
    summary?: string | null;
    is_active?: boolean;
    block_all?: boolean;
    silence_activity?: boolean;
    silence_notifications?: boolean;
    reject_media?: boolean;
};
export type PatchedManageInstancePolicyRequest = {
    target?: ManageTargetRequest;
    summary?: string | null;
    is_active?: boolean;
    block_all?: boolean;
    silence_activity?: boolean;
    silence_notifications?: boolean;
    reject_media?: boolean;
};
export type ManageNote = {
    id: number;
    uuid: string;
    creation_date: string;
    summary: string;
    author: ManageBaseActor;
    target: {
        [key: string]: any;
    };
};
export type PaginatedManageNoteList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageNote[];
};
export type ManageNoteRequest = {
    summary: string;
    target: {
        [key: string]: any;
    };
};
export type ReportTypeEnum = "takedown_request" | "invalid_metadata" | "illegal_content" | "offensive_content" | "other";
export type ManageBaseNote = {
    id: number;
    uuid: string;
    creation_date: string;
    summary: string;
    author: ManageBaseActor;
};
export type ManageReport = {
    id: number;
    uuid: string;
    fid: string;
    creation_date: string;
    handled_date: string | null;
    summary: string | null;
    "type": ReportTypeEnum;
    target: {
        [key: string]: any;
    };
    target_state: {
        [key: string]: any;
    } | null;
    is_handled?: boolean;
    assigned_to?: (ManageBaseActor) | null;
    target_owner?: ManageBaseActor;
    submitter?: ManageBaseActor;
    submitter_email: string | null;
    notes?: ManageBaseNote[] | null;
};
export type PaginatedManageReportList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageReport[];
};
export type ManageBaseNoteRequest = {
    summary: string;
};
export type ManageReportRequest = {
    "type": ReportTypeEnum;
    target: {
        [key: string]: any;
    };
    is_handled?: boolean;
    assigned_to?: (ManageBaseActorRequest) | null;
    target_owner?: ManageBaseActorRequest;
    submitter?: ManageBaseActorRequest;
    notes?: ManageBaseNoteRequest[] | null;
};
export type PatchedManageReportRequest = {
    "type"?: ReportTypeEnum;
    target?: {
        [key: string]: any;
    };
    is_handled?: boolean;
    assigned_to?: (ManageBaseActorRequest) | null;
    target_owner?: ManageBaseActorRequest;
    submitter?: ManageBaseActorRequest;
    notes?: ManageBaseNoteRequest[] | null;
};
export type PaginatedManageUserRequestList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageUserRequest[];
};
export type ManageUserRequestTypeEnum = "signup";
export type ManageUserRequestStatusEnum = "pending" | "refused" | "approved";
export type ManageUserRequestRequest = {
    "type": ManageUserRequestTypeEnum;
    status?: ManageUserRequestStatusEnum;
    assigned_to: ManageBaseActorRequest;
    submitter: ManageBaseActorRequest;
};
export type PatchedManageUserRequestRequest = {
    "type"?: ManageUserRequestTypeEnum;
    status?: ManageUserRequestStatusEnum;
    assigned_to?: ManageBaseActorRequest;
    submitter?: ManageBaseActorRequest;
};
export type ManageTag = {
    id: number;
    name: string;
    creation_date?: string;
    tracks_count: number;
    albums_count: number;
    artists_count: number;
};
export type PaginatedManageTagList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageTag[];
};
export type ManageTagRequest = {
    name: string;
    creation_date?: string;
};
export type ManageUserSimple = {
    id: number;
    username: string;
    email?: string;
    name?: string;
    is_active?: boolean;
    is_staff?: boolean;
    is_superuser?: boolean;
    date_joined?: string;
    last_activity?: string | null;
    privacy_level?: PrivacyLevelEnum;
    upload_quota?: number | null;
};
export type ManageInvitation = {
    id: number;
    owner?: ManageUserSimple;
    code?: string | null;
    expiration_date: string;
    creation_date: string;
    users?: ManageUserSimple[];
};
export type PaginatedManageInvitationList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageInvitation[];
};
export type ManageUserSimpleRequest = {
    username: string;
    email?: string;
    name?: string;
    is_active?: boolean;
    is_staff?: boolean;
    is_superuser?: boolean;
    date_joined?: string;
    last_activity?: string | null;
    privacy_level?: PrivacyLevelEnum;
    upload_quota?: number | null;
};
export type ManageInvitationRequest = {
    owner?: ManageUserSimpleRequest;
    code?: string | null;
    users?: ManageUserSimpleRequest[];
};
export type PatchedManageInvitationRequest = {
    owner?: ManageUserSimpleRequest;
    code?: string | null;
    users?: ManageUserSimpleRequest[];
};
export type PaginatedManageUserList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: ManageUser[];
};
export type PatchedManageUserRequest = {
    name?: string;
    is_active?: boolean;
    is_staff?: boolean;
    is_superuser?: boolean;
    upload_quota?: number | null;
};
export type ModerationTargetTypeEnum = "artist";
export type ModerationTarget = {
    "type": ModerationTargetTypeEnum;
    id: string;
};
export type UserFilter = {
    uuid: string;
    target: ModerationTarget;
    creation_date: string;
};
export type PaginatedUserFilterList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: UserFilter[];
};
export type ModerationTargetRequest = {
    "type": ModerationTargetTypeEnum;
    id: string;
};
export type UserFilterRequest = {
    target: ModerationTargetRequest;
};
export type ReportRequest = {
    summary?: string | null;
    submitter_email?: string | null;
    target: {
        [key: string]: any;
    };
    "type": ReportTypeEnum;
};
export type Report = {
    uuid: string;
    summary?: string | null;
    creation_date: string;
    handled_date: string | null;
    is_handled: boolean;
    submitter_email?: string | null;
    target: {
        [key: string]: any;
    };
    "type": ReportTypeEnum;
};
export type ApiMutationRequest = {
    "type": string;
    applied_date?: string | null;
    is_approved?: boolean | null;
    summary?: string | null;
    payload: {
        [key: string]: any;
    };
};
export type Application = {
    client_id?: string;
    name?: string;
    scopes: string;
    created: string;
    updated: string;
};
export type PaginatedApplicationList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Application[];
};
export type CreateApplicationRequest = {
    name: string;
    scopes?: string;
    redirect_uris?: string;
};
export type CreateApplication = {
    client_id: string;
    name: string;
    scopes?: string;
    client_secret: string;
    created: string;
    updated: string;
    redirect_uris?: string;
};
export type ApplicationRequest = {
    client_id?: string;
    name?: string;
    scopes: string;
};
export type PatchedApplicationRequest = {
    client_id?: string;
    name?: string;
    scopes?: string;
};
export type FormatEnum = "json";
export type Oembed = {
    format: FormatEnum;
    url: string;
    maxheight?: number;
    maxwidth?: number;
};
export type Playlist = {
    id: number;
    name: string;
    user: UserBasic;
    modification_date: string;
    creation_date: string;
    privacy_level?: PrivacyLevelEnum;
    tracks_count: number;
    album_covers: string[];
    duration: number;
    is_playable: boolean;
    actor: ApiActor;
};
export type PaginatedPlaylistList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Playlist[];
};
export type PlaylistRequest = {
    name: string;
    privacy_level?: PrivacyLevelEnum;
};
export type PatchedPlaylistRequest = {
    name?: string;
    privacy_level?: PrivacyLevelEnum;
};
export type PlaylistAddManyRequest = {
    tracks: number[];
    allow_duplicates?: boolean;
};
export type PlaylistTrack = {
    track: string;
    index?: number | null;
    creation_date?: string;
};
export type PaginatedPlaylistTrackList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: PlaylistTrack[];
};
export type Radio = {
    id: number;
    is_public?: boolean;
    name: string;
    creation_date: string;
    user: UserBasic;
    config: {
        [key: string]: any;
    };
    description?: string;
};
export type PaginatedRadioList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Radio[];
};
export type RadioRequest = {
    is_public?: boolean;
    name: string;
    config: {
        [key: string]: any;
    };
    description?: string;
};
export type PatchedRadioRequest = {
    is_public?: boolean;
    name?: string;
    config?: {
        [key: string]: any;
    };
    description?: string;
};
export type Filter = {
    "type": string;
    label: string;
    help_text: string;
    fields: string;
};
export type RadioSessionRequest = {
    radio_type: string;
    related_object_id?: string | null;
    user?: number | null;
    creation_date?: string;
    custom_radio?: number | null;
    config?: {
        [key: string]: any;
    } | null;
};
export type RadioSession = {
    id: number;
    radio_type: string;
    related_object_id?: string | null;
    user?: number | null;
    creation_date?: string;
    custom_radio?: number | null;
    config?: {
        [key: string]: any;
    } | null;
};
export type RadioSessionTrackSerializerCreateRequest = {
    session: number;
};
export type RadioSessionTrackSerializerCreate = {
    session: number;
};
export type Ident = {
    "type": string;
    id: number;
};
export type Scopes = {
    id: string;
    rate: string;
    description: string;
    limit: number;
    duration: number;
    remaining: number;
    available: number;
    available_seconds: number;
    reset: number;
    reset_seconds: number;
};
export type RateLimit = {
    enabled: boolean;
    ident: Ident;
    scopes: Scopes[];
};
export type Tag = {
    name: string;
    creation_date?: string;
};
export type SearchResult = {
    artists: ArtistWithAlbums[];
    tracks: Track[];
    albums: Album[];
    tags: Tag[];
};
export type Subscription = {
    approved: boolean;
    fid: string;
    uuid: string;
    creation_date: string;
};
export type PaginatedSubscriptionList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Subscription[];
};
export type InlineSubscription = {
    uuid: string;
    channel: string;
};
export type AllSubscriptions = {
    results: InlineSubscription[];
    count: number;
};
export type PaginatedTagList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Tag[];
};
export type TextPreviewRequest = {
    text: string;
};
export type TextPreview = {
    rendered: string;
};
export type ErrorDetail = {
    detail: string;
};
export type PaginatedTrackList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: Track[];
};
export type TrackRequest = {
    artist: SimpleArtistRequest;
    attributed_to: (ApiActorRequest) | null;
    id: number;
    fid: string;
    mbid: string;
    title: string;
    creation_date: string;
    is_local: boolean;
    position: number;
    disc_number: number;
    downloads_count: number;
    copyright: string;
    cover: (CoverFieldRequest) | null;
};
export type UploadForOwner = {
    uuid: string;
    filename?: string;
    creation_date: string;
    mimetype: string | null;
    track?: (Track) | null;
    library?: string;
    channel?: string;
    duration: number | null;
    bitrate: number | null;
    size: number | null;
    import_date: string | null;
    import_status?: ImportStatusEnum;
    import_details: {
        [key: string]: any;
    };
    import_metadata?: {
        [key: string]: any;
    };
    import_reference?: string;
    metadata: {
        [key: string]: any;
    };
    source?: string | null;
};
export type PaginatedUploadForOwnerList = {
    count?: number;
    next?: string | null;
    previous?: string | null;
    results?: UploadForOwner[];
};
export type UploadForOwnerRequest = {
    filename?: string;
    track?: (TrackRequest) | null;
    library?: string;
    channel?: string;
    import_status?: ImportStatusEnum;
    import_metadata?: {
        [key: string]: any;
    };
    import_reference?: string;
    source?: string | null;
    audio_file: Blob;
};
export type PatchedUploadForOwnerRequest = {
    filename?: string;
    track?: (TrackRequest) | null;
    library?: string;
    channel?: string;
    import_status?: ImportStatusEnum;
    import_metadata?: {
        [key: string]: any;
    };
    import_reference?: string;
    source?: string | null;
    audio_file?: Blob;
};
export type TrackMetadata = {
    title?: string | null;
    position?: string | null;
    disc_number?: string | null;
    copyright?: string | null;
    license?: string | null;
    mbid?: string | null;
    tags?: string | null;
    description?: string | null;
    album: string;
    artists: string;
    cover_data?: string;
};
export type UserWriteRequest = {
    name?: string;
    privacy_level?: PrivacyLevelEnum;
    avatar: string;
    instance_support_message_display_date?: string | null;
    funkwhale_support_message_display_date?: string | null;
    summary?: (ContentRequest) | null;
};
export type UserWrite = {
    name?: string;
    privacy_level?: PrivacyLevelEnum;
    instance_support_message_display_date?: string | null;
    funkwhale_support_message_display_date?: string | null;
    summary?: (Content) | null;
};
export type PatchedUserWriteRequest = {
    name?: string;
    privacy_level?: PrivacyLevelEnum;
    avatar?: string;
    instance_support_message_display_date?: string | null;
    funkwhale_support_message_display_date?: string | null;
    summary?: (ContentRequest) | null;
};
export function getActivity({ ordering, page, pageSize }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/activity/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize
    }))}`, {
        ...opts
    });
}
export function getAlbums({ artist, channel, contentCategory, hidden, includeChannels, library, mbid, ordering, page, pageSize, playable, q, related, scope, tag }: {
    artist?: number;
    channel?: string;
    contentCategory?: string;
    hidden?: boolean;
    includeChannels?: boolean;
    library?: string;
    mbid?: string;
    ordering?: ("-artist__modification_date" | "-creation_date" | "-random" | "-related" | "-release_date" | "-title" | "artist__modification_date" | "creation_date" | "random" | "related" | "release_date" | "title")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedAlbumList;
    }>(`/api/v1/albums/${QS.query(QS.explode({
        artist,
        channel,
        content_category: contentCategory,
        hidden,
        include_channels: includeChannels,
        library,
        mbid,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function createAlbum(albumCreateRequest: AlbumCreateRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: AlbumCreate;
    }>("/api/v1/albums/", oazapfts.json({
        ...opts,
        method: "POST",
        body: albumCreateRequest
    }));
}
export function getAlbum(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Album;
    }>(`/api/v1/albums/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function deleteAlbum(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/albums/${encodeURIComponent(id)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function getAlbumFetches(id: number, { artist, channel, contentCategory, hidden, includeChannels, library, mbid, ordering, page, pageSize, playable, q, related, scope, tag }: {
    artist?: number;
    channel?: string;
    contentCategory?: string;
    hidden?: boolean;
    includeChannels?: boolean;
    library?: string;
    mbid?: string;
    ordering?: ("-artist__modification_date" | "-creation_date" | "-random" | "-related" | "-release_date" | "-title" | "artist__modification_date" | "creation_date" | "random" | "related" | "release_date" | "title")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedFetchList;
    }>(`/api/v1/albums/${encodeURIComponent(id)}/fetches/${QS.query(QS.explode({
        artist,
        channel,
        content_category: contentCategory,
        hidden,
        include_channels: includeChannels,
        library,
        mbid,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function createAlbumFetch(id: number, albumRequest: AlbumRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Fetch;
    }>(`/api/v1/albums/${encodeURIComponent(id)}/fetches/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: albumRequest
    }));
}
export function getAlbumLibraries(id: number, { artist, channel, contentCategory, hidden, includeChannels, library, mbid, ordering, page, pageSize, playable, q, related, scope, tag }: {
    artist?: number;
    channel?: string;
    contentCategory?: string;
    hidden?: boolean;
    includeChannels?: boolean;
    library?: string;
    mbid?: string;
    ordering?: ("-artist__modification_date" | "-creation_date" | "-random" | "-related" | "-release_date" | "-title" | "artist__modification_date" | "creation_date" | "random" | "related" | "release_date" | "title")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedLibraryList;
    }>(`/api/v1/albums/${encodeURIComponent(id)}/libraries/${QS.query(QS.explode({
        artist,
        channel,
        content_category: contentCategory,
        hidden,
        include_channels: includeChannels,
        library,
        mbid,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function getAlbumMutations(id: number, { artist, channel, contentCategory, hidden, includeChannels, library, mbid, ordering, page, pageSize, playable, q, related, scope, tag }: {
    artist?: number;
    channel?: string;
    contentCategory?: string;
    hidden?: boolean;
    includeChannels?: boolean;
    library?: string;
    mbid?: string;
    ordering?: ("-artist__modification_date" | "-creation_date" | "-random" | "-related" | "-release_date" | "-title" | "artist__modification_date" | "creation_date" | "random" | "related" | "release_date" | "title")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedApiMutationList;
    }>(`/api/v1/albums/${encodeURIComponent(id)}/mutations/${QS.query(QS.explode({
        artist,
        channel,
        content_category: contentCategory,
        hidden,
        include_channels: includeChannels,
        library,
        mbid,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function createAlbumMutation(id: number, albumRequest: AlbumRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ApiMutation;
    }>(`/api/v1/albums/${encodeURIComponent(id)}/mutations/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: albumRequest
    }));
}
export function getArtists({ contentCategory, hasAlbums, hidden, includeChannels, library, mbid, name, nameIcontains, nameIexact, nameStartswith, ordering, page, pageSize, playable, q, related, scope, tag }: {
    contentCategory?: string;
    hasAlbums?: boolean;
    hidden?: boolean;
    includeChannels?: boolean;
    library?: string;
    mbid?: string;
    name?: string;
    nameIcontains?: string;
    nameIexact?: string;
    nameStartswith?: string;
    ordering?: ("-creation_date" | "-id" | "-modification_date" | "-name" | "-random" | "-related" | "creation_date" | "id" | "modification_date" | "name" | "random" | "related")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedArtistWithAlbumsList;
    }>(`/api/v1/artists/${QS.query(QS.explode({
        content_category: contentCategory,
        has_albums: hasAlbums,
        hidden,
        include_channels: includeChannels,
        library,
        mbid,
        name,
        name__icontains: nameIcontains,
        name__iexact: nameIexact,
        name__startswith: nameStartswith,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function getArtist(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ArtistWithAlbums;
    }>(`/api/v1/artists/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function getArtistFetches(id: number, { contentCategory, hasAlbums, hidden, includeChannels, library, mbid, name, nameIcontains, nameIexact, nameStartswith, ordering, page, pageSize, playable, q, related, scope, tag }: {
    contentCategory?: string;
    hasAlbums?: boolean;
    hidden?: boolean;
    includeChannels?: boolean;
    library?: string;
    mbid?: string;
    name?: string;
    nameIcontains?: string;
    nameIexact?: string;
    nameStartswith?: string;
    ordering?: ("-creation_date" | "-id" | "-modification_date" | "-name" | "-random" | "-related" | "creation_date" | "id" | "modification_date" | "name" | "random" | "related")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedFetchList;
    }>(`/api/v1/artists/${encodeURIComponent(id)}/fetches/${QS.query(QS.explode({
        content_category: contentCategory,
        has_albums: hasAlbums,
        hidden,
        include_channels: includeChannels,
        library,
        mbid,
        name,
        name__icontains: nameIcontains,
        name__iexact: nameIexact,
        name__startswith: nameStartswith,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function createArtistFetch(id: number, artistWithAlbumsRequest: ArtistWithAlbumsRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Fetch;
    }>(`/api/v1/artists/${encodeURIComponent(id)}/fetches/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: artistWithAlbumsRequest
    }));
}
export function getArtistLibraries(id: number, { contentCategory, hasAlbums, hidden, includeChannels, library, mbid, name, nameIcontains, nameIexact, nameStartswith, ordering, page, pageSize, playable, q, related, scope, tag }: {
    contentCategory?: string;
    hasAlbums?: boolean;
    hidden?: boolean;
    includeChannels?: boolean;
    library?: string;
    mbid?: string;
    name?: string;
    nameIcontains?: string;
    nameIexact?: string;
    nameStartswith?: string;
    ordering?: ("-creation_date" | "-id" | "-modification_date" | "-name" | "-random" | "-related" | "creation_date" | "id" | "modification_date" | "name" | "random" | "related")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedLibraryList;
    }>(`/api/v1/artists/${encodeURIComponent(id)}/libraries/${QS.query(QS.explode({
        content_category: contentCategory,
        has_albums: hasAlbums,
        hidden,
        include_channels: includeChannels,
        library,
        mbid,
        name,
        name__icontains: nameIcontains,
        name__iexact: nameIexact,
        name__startswith: nameStartswith,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function getArtistMutations(id: number, { contentCategory, hasAlbums, hidden, includeChannels, library, mbid, name, nameIcontains, nameIexact, nameStartswith, ordering, page, pageSize, playable, q, related, scope, tag }: {
    contentCategory?: string;
    hasAlbums?: boolean;
    hidden?: boolean;
    includeChannels?: boolean;
    library?: string;
    mbid?: string;
    name?: string;
    nameIcontains?: string;
    nameIexact?: string;
    nameStartswith?: string;
    ordering?: ("-creation_date" | "-id" | "-modification_date" | "-name" | "-random" | "-related" | "creation_date" | "id" | "modification_date" | "name" | "random" | "related")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedApiMutationList;
    }>(`/api/v1/artists/${encodeURIComponent(id)}/mutations/${QS.query(QS.explode({
        content_category: contentCategory,
        has_albums: hasAlbums,
        hidden,
        include_channels: includeChannels,
        library,
        mbid,
        name,
        name__icontains: nameIcontains,
        name__iexact: nameIexact,
        name__startswith: nameStartswith,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function createArtistMutation(id: number, artistWithAlbumsRequest: ArtistWithAlbumsRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ApiMutation;
    }>(`/api/v1/artists/${encodeURIComponent(id)}/mutations/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: artistWithAlbumsRequest
    }));
}
export function createAttachment(attachmentRequest: AttachmentRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: Attachment;
    }>("/api/v1/attachments/", oazapfts.json({
        ...opts,
        method: "POST",
        body: attachmentRequest
    }));
}
export function getAttachment(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Attachment;
    }>(`/api/v1/attachments/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function deleteAttachment(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/attachments/${encodeURIComponent(uuid)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function getAttachmentProxy(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Attachment;
    }>(`/api/v1/attachments/${encodeURIComponent(uuid)}/proxy/`, {
        ...opts
    });
}
/**
 * Calls Django Auth SetPasswordForm save method.
 *
 * Accepts the following POST parameters: new_password1, new_password2
 * Returns the success/fail message.
 */
export function changePassword(passwordChangeRequest: PasswordChangeRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PasswordChange;
    }>("/api/v1/auth/password/change/", oazapfts.json({
        ...opts,
        method: "POST",
        body: passwordChangeRequest
    }));
}
/**
 * Calls Django Auth PasswordResetForm save method.
 *
 * Accepts the following POST parameters: email
 * Returns the success/fail message.
 */
export function resetPassword(passwordResetRequest: PasswordResetRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PasswordReset;
    }>("/api/v1/auth/password/reset/", oazapfts.json({
        ...opts,
        method: "POST",
        body: passwordResetRequest
    }));
}
/**
 * Password reset e-mail link is confirmed, therefore
 * this resets the user's password.
 *
 * Accepts the following POST parameters: token, uid,
 *     new_password1, new_password2
 * Returns the success/fail message.
 */
export function confirmPasswordReset(passwordResetConfirmRequest: PasswordResetConfirmRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PasswordResetConfirm;
    }>("/api/v1/auth/password/reset/confirm/", oazapfts.json({
        ...opts,
        method: "POST",
        body: passwordResetConfirmRequest
    }));
}
export function register(registerRequest: RegisterRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: Register;
    }>("/api/v1/auth/registration/", oazapfts.json({
        ...opts,
        method: "POST",
        body: registerRequest
    }));
}
/**
 * Calls Django Auth SetPasswordForm save method.
 *
 * Accepts the following POST parameters: new_password1, new_password2
 * Returns the success/fail message.
 */
export function changePassword2(passwordChangeRequest: PasswordChangeRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PasswordChange;
    }>("/api/v1/auth/registration/change-password/", oazapfts.json({
        ...opts,
        method: "POST",
        body: passwordChangeRequest
    }));
}
export function verifyEmail(verifyEmailRequest: VerifyEmailRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: VerifyEmail;
    }>("/api/v1/auth/registration/verify-email/", oazapfts.json({
        ...opts,
        method: "POST",
        body: verifyEmailRequest
    }));
}
/**
 * Reads and updates UserModel fields
 * Accepts GET, PUT, PATCH methods.
 *
 * Default accepted fields: username, first_name, last_name
 * Default display fields: pk, username, email, first_name, last_name
 * Read-only fields: pk, email
 *
 * Returns UserModel fields.
 */
export function getAuthUser(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UserDetails;
    }>("/api/v1/auth/user/", {
        ...opts
    });
}
/**
 * Reads and updates UserModel fields
 * Accepts GET, PUT, PATCH methods.
 *
 * Default accepted fields: username, first_name, last_name
 * Default display fields: pk, username, email, first_name, last_name
 * Read-only fields: pk, email
 *
 * Returns UserModel fields.
 */
export function updateAuthUser(userDetailsRequest: UserDetailsRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UserDetails;
    }>("/api/v1/auth/user/", oazapfts.json({
        ...opts,
        method: "PUT",
        body: userDetailsRequest
    }));
}
/**
 * Reads and updates UserModel fields
 * Accepts GET, PUT, PATCH methods.
 *
 * Default accepted fields: username, first_name, last_name
 * Default display fields: pk, username, email, first_name, last_name
 * Read-only fields: pk, email
 *
 * Returns UserModel fields.
 */
export function partialUpdateAuthUser(patchedUserDetailsRequest?: PatchedUserDetailsRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UserDetails;
    }>("/api/v1/auth/user/", oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedUserDetailsRequest
    }));
}
export function getChannels({ external, hidden, ordering, page, pageSize, q, scope, subscribed, tag }: {
    external?: boolean;
    hidden?: boolean;
    ordering?: ("-creation_date" | "-modification_date" | "-random" | "creation_date" | "modification_date" | "random")[];
    page?: number;
    pageSize?: number;
    q?: string;
    scope?: string;
    subscribed?: boolean;
    tag?: string[];
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedChannelList;
    }>(`/api/v1/channels/${QS.query(QS.explode({
        external,
        hidden,
        page,
        page_size: pageSize,
        q,
        scope,
        subscribed,
        tag
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function createChannel(channelCreateRequest: ChannelCreateRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: ChannelCreate;
    }>("/api/v1/channels/", oazapfts.json({
        ...opts,
        method: "POST",
        body: channelCreateRequest
    }));
}
export function getChannel(composite: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Channel;
    }>(`/api/v1/channels/${encodeURIComponent(composite)}/`, {
        ...opts
    });
}
export function updateChannel(composite: string, channelUpdateRequest: ChannelUpdateRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ChannelUpdate;
    }>(`/api/v1/channels/${encodeURIComponent(composite)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: channelUpdateRequest
    }));
}
export function partialUpdateChannel(composite: string, patchedChannelUpdateRequest?: PatchedChannelUpdateRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ChannelUpdate;
    }>(`/api/v1/channels/${encodeURIComponent(composite)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedChannelUpdateRequest
    }));
}
export function deleteChannel(composite: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/channels/${encodeURIComponent(composite)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function getChannelRss(composite: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Channel;
    }>(`/api/v1/channels/${encodeURIComponent(composite)}/rss/`, {
        ...opts
    });
}
export function subscribeChannel(composite: string, channelRequest: ChannelRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Channel;
    }>(`/api/v1/channels/${encodeURIComponent(composite)}/subscribe/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: channelRequest
    }));
}
export function unsubscribeChannel2(composite: string, channelRequest: ChannelRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/channels/${encodeURIComponent(composite)}/unsubscribe/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: channelRequest
    }));
}
export function unsubscribeChannel(composite: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/channels/${encodeURIComponent(composite)}/unsubscribe/`, {
        ...opts,
        method: "DELETE"
    });
}
export function getChannelMetadataChoices(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Channel;
    }>("/api/v1/channels/metadata-choices/", {
        ...opts
    });
}
export function subscribeChannelRss(channelRequest: ChannelRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Channel;
    }>("/api/v1/channels/rss-subscribe/", oazapfts.json({
        ...opts,
        method: "POST",
        body: channelRequest
    }));
}
export function getFavoriteTracks({ hidden, ordering, page, pageSize, q, scope }: {
    hidden?: boolean;
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
    scope?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedUserTrackFavoriteList;
    }>(`/api/v1/favorites/tracks/${QS.query(QS.explode({
        hidden,
        ordering,
        page,
        page_size: pageSize,
        q,
        scope
    }))}`, {
        ...opts
    });
}
export function favoriteTrack(userTrackFavoriteWriteRequest: UserTrackFavoriteWriteRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: UserTrackFavoriteWrite;
    }>("/api/v1/favorites/tracks/", oazapfts.json({
        ...opts,
        method: "POST",
        body: userTrackFavoriteWriteRequest
    }));
}
export function deleteFavoriteTrack(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/favorites/tracks/${encodeURIComponent(id)}/`, {
        ...opts,
        method: "DELETE"
    });
}
/**
 * Return all the favorites of the current user, with only limited data
 * to have a performant endpoint and avoid lots of queries just to display
 * favorites status in the UI
 */
export function getAllFavoriteTracks(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: AllFavorite;
    }>("/api/v1/favorites/tracks/all/", {
        ...opts
    });
}
export function unfavoriteTrack2(userTrackFavoriteWriteRequest: UserTrackFavoriteWriteRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UserTrackFavoriteWrite;
    }>("/api/v1/favorites/tracks/remove/", oazapfts.json({
        ...opts,
        method: "POST",
        body: userTrackFavoriteWriteRequest
    }));
}
export function unfavoriteTrack(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText("/api/v1/favorites/tracks/remove/", {
        ...opts,
        method: "DELETE"
    });
}
export function getFederationActor(fullUsername: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: FullActor;
    }>(`/api/v1/federation/actors/${encodeURIComponent(fullUsername)}/`, {
        ...opts
    });
}
export function getFederationActorLibrary(fullUsername: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: LibraryForOwner;
    }>(`/api/v1/federation/actors/${encodeURIComponent(fullUsername)}/libraries/`, {
        ...opts
    });
}
export function getFederationDomains({ ordering, page, pageSize }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedDomainList;
    }>(`/api/v1/federation/domains/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize
    }))}`, {
        ...opts
    });
}
export function getFederationDomain(name: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Domain;
    }>(`/api/v1/federation/domains/${encodeURIComponent(name)}/`, {
        ...opts
    });
}
export function createFederationFetch(fetchRequest: FetchRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: Fetch;
    }>("/api/v1/federation/fetches/", oazapfts.json({
        ...opts,
        method: "POST",
        body: fetchRequest
    }));
}
export function getFederationFetch(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Fetch;
    }>(`/api/v1/federation/fetches/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function getFederationLibraryFollows({ approved, ordering, page, pageSize }: {
    approved?: boolean;
    ordering?: string;
    page?: number;
    pageSize?: number;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedLibraryFollowList;
    }>(`/api/v1/federation/follows/library/${QS.query(QS.explode({
        approved,
        ordering,
        page,
        page_size: pageSize
    }))}`, {
        ...opts
    });
}
export function createFederationLibraryFollow(libraryFollowRequest: LibraryFollowRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: LibraryFollow;
    }>("/api/v1/federation/follows/library/", oazapfts.json({
        ...opts,
        method: "POST",
        body: libraryFollowRequest
    }));
}
export function getFederationLibraryFollow(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: LibraryFollow;
    }>(`/api/v1/federation/follows/library/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function deleteFederationLibraryFollow(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/federation/follows/library/${encodeURIComponent(uuid)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function acceptFederationLibraryFollow(uuid: string, libraryFollowRequest: LibraryFollowRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/federation/follows/library/${encodeURIComponent(uuid)}/accept/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: libraryFollowRequest
    }));
}
export function rejectFederationLibraryFollow(uuid: string, libraryFollowRequest: LibraryFollowRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: LibraryFollow;
    }>(`/api/v1/federation/follows/library/${encodeURIComponent(uuid)}/reject/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: libraryFollowRequest
    }));
}
/**
 * Return all the subscriptions of the current user, with only limited data
 * to have a performant endpoint and avoid lots of queries just to display
 * subscription status in the UI
 */
export function getAllFederationLibraryFollows(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: LibraryFollow;
    }>("/api/v1/federation/follows/library/all/", {
        ...opts
    });
}
export function getFederationInboxes({ activityActor, activityType, before, isRead, ordering, page, pageSize }: {
    activityActor?: number;
    activityType?: string;
    before?: number;
    isRead?: boolean;
    ordering?: string;
    page?: number;
    pageSize?: number;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedInboxItemList;
    }>(`/api/v1/federation/inbox/${QS.query(QS.explode({
        activity__actor: activityActor,
        activity__type: activityType,
        before,
        is_read: isRead,
        ordering,
        page,
        page_size: pageSize
    }))}`, {
        ...opts
    });
}
export function getFederationInbox(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: InboxItem;
    }>(`/api/v1/federation/inbox/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function updateFederationInbox(id: number, inboxItemRequest: InboxItemRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: InboxItem;
    }>(`/api/v1/federation/inbox/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: inboxItemRequest
    }));
}
export function partialUpdateFederationInbox(id: number, patchedInboxItemRequest?: PatchedInboxItemRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: InboxItem;
    }>(`/api/v1/federation/inbox/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedInboxItemRequest
    }));
}
/**
 * str(object='') -> str
 * str(bytes_or_buffer[, encoding[, errors]]) -> str
 *
 * Create a new string object from the given object. If encoding or
 * errors is specified, then the object must expose a data buffer
 * that will be decoded using the given encoding and error handler.
 * Otherwise, returns the result of object.__str__() (if defined)
 * or repr(object).
 * encoding defaults to sys.getdefaultencoding().
 * errors defaults to 'strict'.
 */
export function createFederationInboxAction(inboxItemRequest: InboxItemRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: InboxItem;
    }>("/api/v1/federation/inbox/action/", oazapfts.json({
        ...opts,
        method: "POST",
        body: inboxItemRequest
    }));
}
export function getFederationLibrary(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Library;
    }>(`/api/v1/federation/libraries/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function createFederationLibraryScan(uuid: string, libraryRequest: LibraryRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Library;
    }>(`/api/v1/federation/libraries/${encodeURIComponent(uuid)}/scan/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: libraryRequest
    }));
}
export function createFederationLibraryFetch(libraryRequest: LibraryRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Library;
    }>("/api/v1/federation/libraries/fetch/", oazapfts.json({
        ...opts,
        method: "POST",
        body: libraryRequest
    }));
}
export function getHistoryListenings({ domain, hidden, ordering, page, pageSize, scope, username }: {
    domain?: string;
    hidden?: boolean;
    ordering?: string;
    page?: number;
    pageSize?: number;
    scope?: string;
    username?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedListeningList;
    }>(`/api/v1/history/listenings/${QS.query(QS.explode({
        domain,
        hidden,
        ordering,
        page,
        page_size: pageSize,
        scope,
        username
    }))}`, {
        ...opts
    });
}
export function createHistoryListening(listeningWriteRequest: ListeningWriteRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: ListeningWrite;
    }>("/api/v1/history/listenings/", oazapfts.json({
        ...opts,
        method: "POST",
        body: listeningWriteRequest
    }));
}
export function getHistoryListening(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Listening;
    }>(`/api/v1/history/listenings/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
/**
 * - list preferences
 * - detail given preference
 * - batch update preferences
 * - update a single preference
 */
export function getInstanceAdminSettings({ ordering }: {
    ordering?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: GlobalPreference[];
    }>(`/api/v1/instance/admin/settings/${QS.query(QS.explode({
        ordering
    }))}`, {
        ...opts
    });
}
/**
 * - list preferences
 * - detail given preference
 * - batch update preferences
 * - update a single preference
 */
export function getInstanceAdminSetting(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: GlobalPreference;
    }>(`/api/v1/instance/admin/settings/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
/**
 * - list preferences
 * - detail given preference
 * - batch update preferences
 * - update a single preference
 */
export function updateInstanceAdminSetting(id: number, globalPreferenceRequest: GlobalPreferenceRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: GlobalPreference;
    }>(`/api/v1/instance/admin/settings/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: globalPreferenceRequest
    }));
}
/**
 * - list preferences
 * - detail given preference
 * - batch update preferences
 * - update a single preference
 */
export function partialUpdateInstanceAdminSetting(id: number, patchedGlobalPreferenceRequest?: PatchedGlobalPreferenceRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: GlobalPreference;
    }>(`/api/v1/instance/admin/settings/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedGlobalPreferenceRequest
    }));
}
/**
 * Update multiple preferences at once
 *
 * this is a long method because we ensure everything is valid
 * before actually persisting the changes
 */
export function createInstanceAdminSettingBulk(globalPreferenceRequest: GlobalPreferenceRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: GlobalPreference;
    }>("/api/v1/instance/admin/settings/bulk/", oazapfts.json({
        ...opts,
        method: "POST",
        body: globalPreferenceRequest
    }));
}
export function getNodeInfo20(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: NodeInfo20;
    }>("/api/v1/instance/nodeinfo/2.0/", {
        ...opts
    });
}
export function getInstanceSettings(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: GlobalPreference;
    }>("/api/v1/instance/settings/", {
        ...opts
    });
}
export function getSpaManifest(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchBlob<{
        status: 200;
        data: Blob;
    }>("/api/v1/instance/spa-manifest.json", {
        ...opts
    });
}
export function getLibraries({ ordering, page, pageSize, privacyLevel, q, scope }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
    privacyLevel?: "everyone" | "instance" | "me";
    q?: string;
    scope?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedLibraryForOwnerList;
    }>(`/api/v1/libraries/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize,
        privacy_level: privacyLevel,
        q,
        scope
    }))}`, {
        ...opts
    });
}
export function createLibrary(libraryForOwnerRequest: LibraryForOwnerRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: LibraryForOwner;
    }>("/api/v1/libraries/", oazapfts.json({
        ...opts,
        method: "POST",
        body: libraryForOwnerRequest
    }));
}
export function getLibrary(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: LibraryForOwner;
    }>(`/api/v1/libraries/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function updateLibrary(uuid: string, libraryForOwnerRequest: LibraryForOwnerRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: LibraryForOwner;
    }>(`/api/v1/libraries/${encodeURIComponent(uuid)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: libraryForOwnerRequest
    }));
}
export function partialUpdateLibrary(uuid: string, patchedLibraryForOwnerRequest?: PatchedLibraryForOwnerRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: LibraryForOwner;
    }>(`/api/v1/libraries/${encodeURIComponent(uuid)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedLibraryForOwnerRequest
    }));
}
export function deleteLibrary(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/libraries/${encodeURIComponent(uuid)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function getLibraryFollows(uuid: string, { ordering, page, pageSize, privacyLevel, q, scope }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
    privacyLevel?: "everyone" | "instance" | "me";
    q?: string;
    scope?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedLibraryFollowList;
    }>(`/api/v1/libraries/${encodeURIComponent(uuid)}/follows/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize,
        privacy_level: privacyLevel,
        q,
        scope
    }))}`, {
        ...opts
    });
}
export function getLibraryFsImport(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText("/api/v1/libraries/fs-import/", {
        ...opts
    });
}
export function createLibraryFsImport(libraryForOwnerRequest: LibraryForOwnerRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText("/api/v1/libraries/fs-import/", oazapfts.json({
        ...opts,
        method: "POST",
        body: libraryForOwnerRequest
    }));
}
export function deleteLibraryFsImport(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText("/api/v1/libraries/fs-import/", {
        ...opts,
        method: "DELETE"
    });
}
export function getLicenses({ ordering, page, pageSize }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedLicenseList;
    }>(`/api/v1/licenses/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize
    }))}`, {
        ...opts
    });
}
export function getLicense(code: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: License;
    }>(`/api/v1/licenses/${encodeURIComponent(code)}/`, {
        ...opts
    });
}
export function getListen(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchBlob<{
        status: 200;
        data: Blob;
    }>(`/api/v1/listen/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function adminGetAccounts({ domain, local, manuallyApprovesFollowers, ordering, page, pageSize, q, type }: {
    domain?: string;
    local?: boolean;
    manuallyApprovesFollowers?: boolean;
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
    "type"?: "Application" | "Group" | "Organization" | "Person" | "Service" | "Tombstone";
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageActorList;
    }>(`/api/v1/manage/accounts/${QS.query(QS.explode({
        domain,
        local,
        manually_approves_followers: manuallyApprovesFollowers,
        ordering,
        page,
        page_size: pageSize,
        q,
        type
    }))}`, {
        ...opts
    });
}
export function adminGetAccount(id: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageActor;
    }>(`/api/v1/manage/accounts/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function adminGetAccountStats(id: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageActor;
    }>(`/api/v1/manage/accounts/${encodeURIComponent(id)}/stats/`, {
        ...opts
    });
}
/**
 * str(object='') -> str
 * str(bytes_or_buffer[, encoding[, errors]]) -> str
 *
 * Create a new string object from the given object. If encoding or
 * errors is specified, then the object must expose a data buffer
 * that will be decoded using the given encoding and error handler.
 * Otherwise, returns the result of object.__str__() (if defined)
 * or repr(object).
 * encoding defaults to sys.getdefaultencoding().
 * errors defaults to 'strict'.
 */
export function adminCreateAccountAction(manageActorRequest: ManageActorRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageActor;
    }>("/api/v1/manage/accounts/action/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageActorRequest
    }));
}
export function adminGetChannels({ ordering, page, pageSize, q }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageChannelList;
    }>(`/api/v1/manage/channels/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize,
        q
    }))}`, {
        ...opts
    });
}
export function adminGetChannel(composite: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageChannel;
    }>(`/api/v1/manage/channels/${encodeURIComponent(composite)}/`, {
        ...opts
    });
}
export function adminDeleteChannel(composite: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/manage/channels/${encodeURIComponent(composite)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function adminGetChannelStats(composite: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageChannel;
    }>(`/api/v1/manage/channels/${encodeURIComponent(composite)}/stats/`, {
        ...opts
    });
}
export function adminGetFederationDomains({ allowed, name, ordering, page, pageSize, q }: {
    allowed?: boolean;
    name?: string;
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageDomainList;
    }>(`/api/v1/manage/federation/domains/${QS.query(QS.explode({
        allowed,
        name,
        ordering,
        page,
        page_size: pageSize,
        q
    }))}`, {
        ...opts
    });
}
export function adminCreateFederationDomain(manageDomainRequest: ManageDomainRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: ManageDomain;
    }>("/api/v1/manage/federation/domains/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageDomainRequest
    }));
}
export function adminGetFederationDomain(name: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageDomain;
    }>(`/api/v1/manage/federation/domains/${encodeURIComponent(name)}/`, {
        ...opts
    });
}
export function adminUpdateFederationDomain(name: string, manageDomainUpdateRequest?: ManageDomainUpdateRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageDomainUpdate;
    }>(`/api/v1/manage/federation/domains/${encodeURIComponent(name)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: manageDomainUpdateRequest
    }));
}
export function adminPartialUpdateFederationDomain(name: string, patchedManageDomainUpdateRequest?: PatchedManageDomainUpdateRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageDomainUpdate;
    }>(`/api/v1/manage/federation/domains/${encodeURIComponent(name)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedManageDomainUpdateRequest
    }));
}
export function adminGetFederationDomainNodeinfo(name: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageDomain;
    }>(`/api/v1/manage/federation/domains/${encodeURIComponent(name)}/nodeinfo/`, {
        ...opts
    });
}
export function adminGetFederationDomainStats(name: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageDomain;
    }>(`/api/v1/manage/federation/domains/${encodeURIComponent(name)}/stats/`, {
        ...opts
    });
}
/**
 * str(object='') -> str
 * str(bytes_or_buffer[, encoding[, errors]]) -> str
 *
 * Create a new string object from the given object. If encoding or
 * errors is specified, then the object must expose a data buffer
 * that will be decoded using the given encoding and error handler.
 * Otherwise, returns the result of object.__str__() (if defined)
 * or repr(object).
 * encoding defaults to sys.getdefaultencoding().
 * errors defaults to 'strict'.
 */
export function adminCreateFederationDomainAction(manageDomainRequest: ManageDomainRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageDomain;
    }>("/api/v1/manage/federation/domains/action/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageDomainRequest
    }));
}
export function adminGetAlbums({ artist, fid, mbid, ordering, page, pageSize, q, title }: {
    artist?: number;
    fid?: string;
    mbid?: string;
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
    title?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageAlbumList;
    }>(`/api/v1/manage/library/albums/${QS.query(QS.explode({
        artist,
        fid,
        mbid,
        ordering,
        page,
        page_size: pageSize,
        q,
        title
    }))}`, {
        ...opts
    });
}
export function adminGetAlbum(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageAlbum;
    }>(`/api/v1/manage/library/albums/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function adminDeleteAlbum(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/manage/library/albums/${encodeURIComponent(id)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function adminGetLibraryAlbumStats(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageAlbum;
    }>(`/api/v1/manage/library/albums/${encodeURIComponent(id)}/stats/`, {
        ...opts
    });
}
/**
 * str(object='') -> str
 * str(bytes_or_buffer[, encoding[, errors]]) -> str
 *
 * Create a new string object from the given object. If encoding or
 * errors is specified, then the object must expose a data buffer
 * that will be decoded using the given encoding and error handler.
 * Otherwise, returns the result of object.__str__() (if defined)
 * or repr(object).
 * encoding defaults to sys.getdefaultencoding().
 * errors defaults to 'strict'.
 */
export function adminCreateAlbumAction(manageAlbumRequest: ManageAlbumRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageAlbum;
    }>("/api/v1/manage/library/albums/action/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageAlbumRequest
    }));
}
export function adminGetArtists({ contentCategory, fid, mbid, name, ordering, page, pageSize, q }: {
    contentCategory?: "music" | "other" | "podcast";
    fid?: string;
    mbid?: string;
    name?: string;
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageArtistList;
    }>(`/api/v1/manage/library/artists/${QS.query(QS.explode({
        content_category: contentCategory,
        fid,
        mbid,
        name,
        ordering,
        page,
        page_size: pageSize,
        q
    }))}`, {
        ...opts
    });
}
export function adminGetArtist(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageArtist;
    }>(`/api/v1/manage/library/artists/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function adminDeleteArtist(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/manage/library/artists/${encodeURIComponent(id)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function adminGetLibraryArtistStats(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageArtist;
    }>(`/api/v1/manage/library/artists/${encodeURIComponent(id)}/stats/`, {
        ...opts
    });
}
/**
 * str(object='') -> str
 * str(bytes_or_buffer[, encoding[, errors]]) -> str
 *
 * Create a new string object from the given object. If encoding or
 * errors is specified, then the object must expose a data buffer
 * that will be decoded using the given encoding and error handler.
 * Otherwise, returns the result of object.__str__() (if defined)
 * or repr(object).
 * encoding defaults to sys.getdefaultencoding().
 * errors defaults to 'strict'.
 */
export function adminCreateArtistAction(manageArtistRequest: ManageArtistRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageArtist;
    }>("/api/v1/manage/library/artists/action/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageArtistRequest
    }));
}
export function adminGetLibraries({ domain, fid, name, ordering, page, pageSize, privacyLevel, q }: {
    domain?: string;
    fid?: string;
    name?: string;
    ordering?: ("-creation_date" | "-followers_count" | "-uploads_count" | "creation_date" | "followers_count" | "uploads_count")[];
    page?: number;
    pageSize?: number;
    privacyLevel?: "everyone" | "instance" | "me";
    q?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageLibraryList;
    }>(`/api/v1/manage/library/libraries/${QS.query(QS.explode({
        domain,
        fid,
        name,
        page,
        page_size: pageSize,
        privacy_level: privacyLevel,
        q
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function adminGetLibrary(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageLibrary;
    }>(`/api/v1/manage/library/libraries/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function adminUpdateLibrary(uuid: string, manageLibraryRequest: ManageLibraryRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageLibrary;
    }>(`/api/v1/manage/library/libraries/${encodeURIComponent(uuid)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: manageLibraryRequest
    }));
}
export function adminPartialUpdateLibrary(uuid: string, patchedManageLibraryRequest?: PatchedManageLibraryRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageLibrary;
    }>(`/api/v1/manage/library/libraries/${encodeURIComponent(uuid)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedManageLibraryRequest
    }));
}
export function adminDeleteLibrary(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/manage/library/libraries/${encodeURIComponent(uuid)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function adminGetLibraryStats(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageLibrary;
    }>(`/api/v1/manage/library/libraries/${encodeURIComponent(uuid)}/stats/`, {
        ...opts
    });
}
/**
 * str(object='') -> str
 * str(bytes_or_buffer[, encoding[, errors]]) -> str
 *
 * Create a new string object from the given object. If encoding or
 * errors is specified, then the object must expose a data buffer
 * that will be decoded using the given encoding and error handler.
 * Otherwise, returns the result of object.__str__() (if defined)
 * or repr(object).
 * encoding defaults to sys.getdefaultencoding().
 * errors defaults to 'strict'.
 */
export function adminCreateLibraryAction(manageLibraryRequest: ManageLibraryRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageLibrary;
    }>("/api/v1/manage/library/libraries/action/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageLibraryRequest
    }));
}
export function adminGetTracks({ album, artist, fid, license, mbid, ordering, page, pageSize, q, title }: {
    album?: number;
    artist?: number;
    fid?: string;
    license?: string;
    mbid?: string;
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
    title?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageTrackList;
    }>(`/api/v1/manage/library/tracks/${QS.query(QS.explode({
        album,
        artist,
        fid,
        license,
        mbid,
        ordering,
        page,
        page_size: pageSize,
        q,
        title
    }))}`, {
        ...opts
    });
}
export function adminGetTrack(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageTrack;
    }>(`/api/v1/manage/library/tracks/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function adminDeleteTrack(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/manage/library/tracks/${encodeURIComponent(id)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function adminGetTrackStats(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageTrack;
    }>(`/api/v1/manage/library/tracks/${encodeURIComponent(id)}/stats/`, {
        ...opts
    });
}
/**
 * str(object='') -> str
 * str(bytes_or_buffer[, encoding[, errors]]) -> str
 *
 * Create a new string object from the given object. If encoding or
 * errors is specified, then the object must expose a data buffer
 * that will be decoded using the given encoding and error handler.
 * Otherwise, returns the result of object.__str__() (if defined)
 * or repr(object).
 * encoding defaults to sys.getdefaultencoding().
 * errors defaults to 'strict'.
 */
export function adminCreateTrackAction(manageTrackRequest: ManageTrackRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageTrack;
    }>("/api/v1/manage/library/tracks/action/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageTrackRequest
    }));
}
export function adminGetUploads({ domain, fid, importReference, importStatus, mimetype, ordering, page, pageSize, privacyLevel, q }: {
    domain?: string;
    fid?: string;
    importReference?: string;
    importStatus?: "draft" | "errored" | "finished" | "pending" | "skipped";
    mimetype?: string;
    ordering?: ("-accessed_date" | "-bitrate" | "-creation_date" | "-duration" | "-modification_date" | "-size" | "accessed_date" | "bitrate" | "creation_date" | "duration" | "modification_date" | "size")[];
    page?: number;
    pageSize?: number;
    privacyLevel?: string;
    q?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageUploadList;
    }>(`/api/v1/manage/library/uploads/${QS.query(QS.explode({
        domain,
        fid,
        import_reference: importReference,
        import_status: importStatus,
        mimetype,
        page,
        page_size: pageSize,
        privacy_level: privacyLevel,
        q
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function adminGetUpload(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageUpload;
    }>(`/api/v1/manage/library/uploads/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function adminDeleteUpload(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/manage/library/uploads/${encodeURIComponent(uuid)}/`, {
        ...opts,
        method: "DELETE"
    });
}
/**
 * str(object='') -> str
 * str(bytes_or_buffer[, encoding[, errors]]) -> str
 *
 * Create a new string object from the given object. If encoding or
 * errors is specified, then the object must expose a data buffer
 * that will be decoded using the given encoding and error handler.
 * Otherwise, returns the result of object.__str__() (if defined)
 * or repr(object).
 * encoding defaults to sys.getdefaultencoding().
 * errors defaults to 'strict'.
 */
export function adminCreateUploadAction(manageUploadRequest: ManageUploadRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageUpload;
    }>("/api/v1/manage/library/uploads/action/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageUploadRequest
    }));
}
export function moderationGetInstancePolicies({ blockAll, ordering, page, pageSize, q, rejectMedia, silenceActivity, silenceNotifications, targetAccountDomain, targetAccountUsername, targetDomain }: {
    blockAll?: boolean;
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
    rejectMedia?: boolean;
    silenceActivity?: boolean;
    silenceNotifications?: boolean;
    targetAccountDomain?: string;
    targetAccountUsername?: string;
    targetDomain?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageInstancePolicyList;
    }>(`/api/v1/manage/moderation/instance-policies/${QS.query(QS.explode({
        block_all: blockAll,
        ordering,
        page,
        page_size: pageSize,
        q,
        reject_media: rejectMedia,
        silence_activity: silenceActivity,
        silence_notifications: silenceNotifications,
        target_account_domain: targetAccountDomain,
        target_account_username: targetAccountUsername,
        target_domain: targetDomain
    }))}`, {
        ...opts
    });
}
export function moderationCreateInstancePolicy(manageInstancePolicyRequest: ManageInstancePolicyRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: ManageInstancePolicy;
    }>("/api/v1/manage/moderation/instance-policies/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageInstancePolicyRequest
    }));
}
export function moderationGetInstancePolicy(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageInstancePolicy;
    }>(`/api/v1/manage/moderation/instance-policies/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function moderationUpdateInstancePolicy(id: number, manageInstancePolicyRequest: ManageInstancePolicyRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageInstancePolicy;
    }>(`/api/v1/manage/moderation/instance-policies/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: manageInstancePolicyRequest
    }));
}
export function moderationPartialUpdateInstancePolicy(id: number, patchedManageInstancePolicyRequest?: PatchedManageInstancePolicyRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageInstancePolicy;
    }>(`/api/v1/manage/moderation/instance-policies/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedManageInstancePolicyRequest
    }));
}
export function moderationDeleteInstancePolicy(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/manage/moderation/instance-policies/${encodeURIComponent(id)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function moderationGetNotes({ ordering, page, pageSize, q }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageNoteList;
    }>(`/api/v1/manage/moderation/notes/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize,
        q
    }))}`, {
        ...opts
    });
}
export function moderationCreateNote(manageNoteRequest: ManageNoteRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: ManageNote;
    }>("/api/v1/manage/moderation/notes/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageNoteRequest
    }));
}
export function moderationGetNote(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageNote;
    }>(`/api/v1/manage/moderation/notes/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function moderationDeleteNote(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/manage/moderation/notes/${encodeURIComponent(uuid)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function moderationGetReports({ isHandled, ordering, page, pageSize, q, submitterEmail, type }: {
    isHandled?: boolean;
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
    submitterEmail?: string;
    "type"?: "illegal_content" | "invalid_metadata" | "offensive_content" | "other" | "takedown_request";
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageReportList;
    }>(`/api/v1/manage/moderation/reports/${QS.query(QS.explode({
        is_handled: isHandled,
        ordering,
        page,
        page_size: pageSize,
        q,
        submitter_email: submitterEmail,
        type
    }))}`, {
        ...opts
    });
}
export function moderationGetReport(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageReport;
    }>(`/api/v1/manage/moderation/reports/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function moderationUpdateReport(uuid: string, manageReportRequest: ManageReportRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageReport;
    }>(`/api/v1/manage/moderation/reports/${encodeURIComponent(uuid)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: manageReportRequest
    }));
}
export function moderationPartialUpdateReport(uuid: string, patchedManageReportRequest?: PatchedManageReportRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageReport;
    }>(`/api/v1/manage/moderation/reports/${encodeURIComponent(uuid)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedManageReportRequest
    }));
}
export function moderationGetRequests({ ordering, page, pageSize, q, status, type }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
    status?: "approved" | "pending" | "refused";
    "type"?: "signup";
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageUserRequestList;
    }>(`/api/v1/manage/moderation/requests/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize,
        q,
        status,
        type
    }))}`, {
        ...opts
    });
}
export function moderationGetRequest(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageUserRequest;
    }>(`/api/v1/manage/moderation/requests/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function moderationUpdateRequest(uuid: string, manageUserRequestRequest: ManageUserRequestRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageUserRequest;
    }>(`/api/v1/manage/moderation/requests/${encodeURIComponent(uuid)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: manageUserRequestRequest
    }));
}
export function moderationPartialUpdateRequest(uuid: string, patchedManageUserRequestRequest?: PatchedManageUserRequestRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageUserRequest;
    }>(`/api/v1/manage/moderation/requests/${encodeURIComponent(uuid)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedManageUserRequestRequest
    }));
}
export function adminGetTags({ ordering, page, pageSize, q }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageTagList;
    }>(`/api/v1/manage/tags/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize,
        q
    }))}`, {
        ...opts
    });
}
export function adminCreateTag(manageTagRequest: ManageTagRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: ManageTag;
    }>("/api/v1/manage/tags/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageTagRequest
    }));
}
export function adminGetTag(name: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageTag;
    }>(`/api/v1/manage/tags/${encodeURIComponent(name)}/`, {
        ...opts
    });
}
export function adminDeleteTag(name: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/manage/tags/${encodeURIComponent(name)}/`, {
        ...opts,
        method: "DELETE"
    });
}
/**
 * str(object='') -> str
 * str(bytes_or_buffer[, encoding[, errors]]) -> str
 *
 * Create a new string object from the given object. If encoding or
 * errors is specified, then the object must expose a data buffer
 * that will be decoded using the given encoding and error handler.
 * Otherwise, returns the result of object.__str__() (if defined)
 * or repr(object).
 * encoding defaults to sys.getdefaultencoding().
 * errors defaults to 'strict'.
 */
export function adminCreateTagAction(manageTagRequest: ManageTagRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageTag;
    }>("/api/v1/manage/tags/action/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageTagRequest
    }));
}
export function adminGetInvitations({ isOpen, ordering, page, pageSize, q }: {
    isOpen?: boolean;
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageInvitationList;
    }>(`/api/v1/manage/users/invitations/${QS.query(QS.explode({
        is_open: isOpen,
        ordering,
        page,
        page_size: pageSize,
        q
    }))}`, {
        ...opts
    });
}
export function adminCreateInvitation(manageInvitationRequest?: ManageInvitationRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: ManageInvitation;
    }>("/api/v1/manage/users/invitations/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageInvitationRequest
    }));
}
export function adminGetInvitation(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageInvitation;
    }>(`/api/v1/manage/users/invitations/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function adminUpdateInvitation(id: number, manageInvitationRequest?: ManageInvitationRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageInvitation;
    }>(`/api/v1/manage/users/invitations/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: manageInvitationRequest
    }));
}
export function adminPartialUpdateInvitation(id: number, patchedManageInvitationRequest?: PatchedManageInvitationRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageInvitation;
    }>(`/api/v1/manage/users/invitations/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedManageInvitationRequest
    }));
}
/**
 * str(object='') -> str
 * str(bytes_or_buffer[, encoding[, errors]]) -> str
 *
 * Create a new string object from the given object. If encoding or
 * errors is specified, then the object must expose a data buffer
 * that will be decoded using the given encoding and error handler.
 * Otherwise, returns the result of object.__str__() (if defined)
 * or repr(object).
 * encoding defaults to sys.getdefaultencoding().
 * errors defaults to 'strict'.
 */
export function adminCreateInvitationAction(manageInvitationRequest?: ManageInvitationRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageInvitation;
    }>("/api/v1/manage/users/invitations/action/", oazapfts.json({
        ...opts,
        method: "POST",
        body: manageInvitationRequest
    }));
}
export function adminGetUsers({ isActive, isStaff, isSuperuser, ordering, page, pageSize, permissionLibrary, permissionModeration, permissionSettings, privacyLevel, q }: {
    isActive?: boolean;
    isStaff?: boolean;
    isSuperuser?: boolean;
    ordering?: string;
    page?: number;
    pageSize?: number;
    permissionLibrary?: boolean;
    permissionModeration?: boolean;
    permissionSettings?: boolean;
    privacyLevel?: "everyone" | "followers" | "instance" | "me";
    q?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedManageUserList;
    }>(`/api/v1/manage/users/users/${QS.query(QS.explode({
        is_active: isActive,
        is_staff: isStaff,
        is_superuser: isSuperuser,
        ordering,
        page,
        page_size: pageSize,
        permission_library: permissionLibrary,
        permission_moderation: permissionModeration,
        permission_settings: permissionSettings,
        privacy_level: privacyLevel,
        q
    }))}`, {
        ...opts
    });
}
export function adminGetUser(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageUser;
    }>(`/api/v1/manage/users/users/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function adminUpdateUser(id: number, manageUserRequest?: ManageUserRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageUser;
    }>(`/api/v1/manage/users/users/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: manageUserRequest
    }));
}
export function adminPartialUpdateUser(id: number, patchedManageUserRequest?: PatchedManageUserRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ManageUser;
    }>(`/api/v1/manage/users/users/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedManageUserRequest
    }));
}
export function getModerationContentFilters({ ordering, page, pageSize }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedUserFilterList;
    }>(`/api/v1/moderation/content-filters/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize
    }))}`, {
        ...opts
    });
}
export function createModerationContentFilter(userFilterRequest: UserFilterRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: UserFilter;
    }>("/api/v1/moderation/content-filters/", oazapfts.json({
        ...opts,
        method: "POST",
        body: userFilterRequest
    }));
}
export function getModerationContentFilter(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UserFilter;
    }>(`/api/v1/moderation/content-filters/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function deleteModerationContentFilter(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/moderation/content-filters/${encodeURIComponent(uuid)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function createModerationReport(reportRequest: ReportRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: Report;
    }>("/api/v1/moderation/reports/", oazapfts.json({
        ...opts,
        method: "POST",
        body: reportRequest
    }));
}
export function getMutations({ isApplied, isApproved, ordering, page, pageSize, q, type }: {
    isApplied?: boolean;
    isApproved?: boolean;
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
    "type"?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedApiMutationList;
    }>(`/api/v1/mutations/${QS.query(QS.explode({
        is_applied: isApplied,
        is_approved: isApproved,
        ordering,
        page,
        page_size: pageSize,
        q,
        type
    }))}`, {
        ...opts
    });
}
export function getMutation(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ApiMutation;
    }>(`/api/v1/mutations/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function deleteMutation(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/mutations/${encodeURIComponent(uuid)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function approveMutation(uuid: string, apiMutationRequest: ApiMutationRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ApiMutation;
    }>(`/api/v1/mutations/${encodeURIComponent(uuid)}/approve/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: apiMutationRequest
    }));
}
export function rejectMutation(uuid: string, apiMutationRequest: ApiMutationRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ApiMutation;
    }>(`/api/v1/mutations/${encodeURIComponent(uuid)}/reject/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: apiMutationRequest
    }));
}
export function getOauthApps({ ordering, page, pageSize }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedApplicationList;
    }>(`/api/v1/oauth/apps/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize
    }))}`, {
        ...opts
    });
}
export function createOauthApp(createApplicationRequest: CreateApplicationRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: CreateApplication;
    }>("/api/v1/oauth/apps/", oazapfts.json({
        ...opts,
        method: "POST",
        body: createApplicationRequest
    }));
}
export function getOauthApp(clientId: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Application;
    }>(`/api/v1/oauth/apps/${encodeURIComponent(clientId)}/`, {
        ...opts
    });
}
export function updateOauthApp(clientId: string, applicationRequest: ApplicationRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Application;
    }>(`/api/v1/oauth/apps/${encodeURIComponent(clientId)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: applicationRequest
    }));
}
export function partialUpdateOauthApp(clientId: string, patchedApplicationRequest?: PatchedApplicationRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Application;
    }>(`/api/v1/oauth/apps/${encodeURIComponent(clientId)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedApplicationRequest
    }));
}
export function deleteOauthApp(clientId: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/oauth/apps/${encodeURIComponent(clientId)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function refreshOauthToken(clientId: string, createApplicationRequest: CreateApplicationRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: CreateApplication;
    }>(`/api/v1/oauth/apps/${encodeURIComponent(clientId)}/refresh-token/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: createApplicationRequest
    }));
}
/**
 * This is a viewset that list applications that have access to the request user
 * account, to allow revoking tokens easily.
 */
export function getOauthGrants({ ordering }: {
    ordering?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Application[];
    }>(`/api/v1/oauth/grants/${QS.query(QS.explode({
        ordering
    }))}`, {
        ...opts
    });
}
/**
 * This is a viewset that list applications that have access to the request user
 * account, to allow revoking tokens easily.
 */
export function getOauthGrant(clientId: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Application;
    }>(`/api/v1/oauth/grants/${encodeURIComponent(clientId)}/`, {
        ...opts
    });
}
/**
 * This is a viewset that list applications that have access to the request user
 * account, to allow revoking tokens easily.
 */
export function deleteOauthGrant(clientId: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/oauth/grants/${encodeURIComponent(clientId)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function getOembed(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Oembed;
    }>("/api/v1/oembed/", {
        ...opts
    });
}
export function getPlaylists({ album, artist, name, nameIcontains, ordering, page, pageSize, playable, q, scope, track }: {
    album?: number;
    artist?: number;
    name?: string;
    nameIcontains?: string;
    ordering?: string;
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    scope?: string;
    track?: number;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedPlaylistList;
    }>(`/api/v1/playlists/${QS.query(QS.explode({
        album,
        artist,
        name,
        name__icontains: nameIcontains,
        ordering,
        page,
        page_size: pageSize,
        playable,
        q,
        scope,
        track
    }))}`, {
        ...opts
    });
}
export function createPlaylist(playlistRequest: PlaylistRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: Playlist;
    }>("/api/v1/playlists/", oazapfts.json({
        ...opts,
        method: "POST",
        body: playlistRequest
    }));
}
export function getPlaylist(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Playlist;
    }>(`/api/v1/playlists/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function updatePlaylist(id: number, playlistRequest: PlaylistRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Playlist;
    }>(`/api/v1/playlists/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: playlistRequest
    }));
}
export function partialUpdatePlaylist(id: number, patchedPlaylistRequest?: PatchedPlaylistRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Playlist;
    }>(`/api/v1/playlists/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedPlaylistRequest
    }));
}
export function deletePlaylist(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/playlists/${encodeURIComponent(id)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function addToPlaylist(id: number, playlistAddManyRequest: PlaylistAddManyRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Playlist;
    }>(`/api/v1/playlists/${encodeURIComponent(id)}/add/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: playlistAddManyRequest
    }));
}
export function clearPlaylist(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/playlists/${encodeURIComponent(id)}/clear/`, {
        ...opts,
        method: "DELETE"
    });
}
export function reorderTrackInPlaylist(id: number, playlistRequest: PlaylistRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Playlist;
    }>(`/api/v1/playlists/${encodeURIComponent(id)}/move/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: playlistRequest
    }));
}
export function removeFromPlaylist2(id: number, playlistRequest: PlaylistRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Playlist;
    }>(`/api/v1/playlists/${encodeURIComponent(id)}/remove/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: playlistRequest
    }));
}
export function removeFromPlaylist(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/playlists/${encodeURIComponent(id)}/remove/`, {
        ...opts,
        method: "DELETE"
    });
}
export function getPlaylistTracks(id: number, { album, artist, name, nameIcontains, ordering, page, pageSize, playable, q, scope, track }: {
    album?: number;
    artist?: number;
    name?: string;
    nameIcontains?: string;
    ordering?: string;
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    scope?: string;
    track?: number;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedPlaylistTrackList;
    }>(`/api/v1/playlists/${encodeURIComponent(id)}/tracks/${QS.query(QS.explode({
        album,
        artist,
        name,
        name__icontains: nameIcontains,
        ordering,
        page,
        page_size: pageSize,
        playable,
        q,
        scope,
        track
    }))}`, {
        ...opts
    });
}
export function getPlugins({ ordering, page, pageSize }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/plugins/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize
    }))}`, {
        ...opts
    });
}
export function createPlugin(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText("/api/v1/plugins/", {
        ...opts,
        method: "POST"
    });
}
export function getPlugin(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/plugins/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function disablePlugin(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/plugins/${encodeURIComponent(id)}/disable/`, {
        ...opts,
        method: "POST"
    });
}
export function enablePlugin(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/plugins/${encodeURIComponent(id)}/enable/`, {
        ...opts,
        method: "POST"
    });
}
export function createPluginScan(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/plugins/${encodeURIComponent(id)}/scan/`, {
        ...opts,
        method: "POST"
    });
}
export function getRadios({ name, nameIcontains, nameIexact, nameStartswith, ordering, page, pageSize, q, scope }: {
    name?: string;
    nameIcontains?: string;
    nameIexact?: string;
    nameStartswith?: string;
    ordering?: string;
    page?: number;
    pageSize?: number;
    q?: string;
    scope?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedRadioList;
    }>(`/api/v1/radios/radios/${QS.query(QS.explode({
        name,
        name__icontains: nameIcontains,
        name__iexact: nameIexact,
        name__startswith: nameStartswith,
        ordering,
        page,
        page_size: pageSize,
        q,
        scope
    }))}`, {
        ...opts
    });
}
export function createRadio(radioRequest: RadioRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: Radio;
    }>("/api/v1/radios/radios/", oazapfts.json({
        ...opts,
        method: "POST",
        body: radioRequest
    }));
}
export function getRadio(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Radio;
    }>(`/api/v1/radios/radios/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function updateRadio(id: number, radioRequest: RadioRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Radio;
    }>(`/api/v1/radios/radios/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: radioRequest
    }));
}
export function partialUpdateRadio(id: number, patchedRadioRequest?: PatchedRadioRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Radio;
    }>(`/api/v1/radios/radios/${encodeURIComponent(id)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedRadioRequest
    }));
}
export function deleteRadio(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/radios/radios/${encodeURIComponent(id)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function getRadioTrack(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Track;
    }>(`/api/v1/radios/radios/${encodeURIComponent(id)}/tracks/`, {
        ...opts
    });
}
export function getRadioFilter(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Filter;
    }>("/api/v1/radios/radios/filters/", {
        ...opts
    });
}
export function validateRadio(radioRequest: RadioRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Radio;
    }>("/api/v1/radios/radios/validate/", oazapfts.json({
        ...opts,
        method: "POST",
        body: radioRequest
    }));
}
export function createRadioSession(radioSessionRequest: RadioSessionRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: RadioSession;
    }>("/api/v1/radios/sessions/", oazapfts.json({
        ...opts,
        method: "POST",
        body: radioSessionRequest
    }));
}
export function getRadioSession(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: RadioSession;
    }>(`/api/v1/radios/sessions/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
export function getNextRadioTrack(radioSessionTrackSerializerCreateRequest: RadioSessionTrackSerializerCreateRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: RadioSessionTrackSerializerCreate;
    }>("/api/v1/radios/tracks/", oazapfts.json({
        ...opts,
        method: "POST",
        body: radioSessionTrackSerializerCreateRequest
    }));
}
export function getRateLimit(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: RateLimit;
    }>("/api/v1/rate-limit/", {
        ...opts
    });
}
export function getSearchResults(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: SearchResult;
    }>("/api/v1/search", {
        ...opts
    });
}
export function getTrackStream(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchBlob<{
        status: 200;
        data: Blob;
    }>(`/api/v1/stream/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function getSubscriptions({ ordering, page, pageSize }: {
    ordering?: string;
    page?: number;
    pageSize?: number;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedSubscriptionList;
    }>(`/api/v1/subscriptions/${QS.query(QS.explode({
        ordering,
        page,
        page_size: pageSize
    }))}`, {
        ...opts
    });
}
export function getSubscription(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Subscription;
    }>(`/api/v1/subscriptions/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
/**
 * Return all the subscriptions of the current user, with only limited data
 * to have a performant endpoint and avoid lots of queries just to display
 * subscription status in the UI
 */
export function getAllSubscriptions(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: AllSubscriptions;
    }>("/api/v1/subscriptions/all/", {
        ...opts
    });
}
export function getTags({ name, nameStartswith, ordering, page, pageSize, q }: {
    name?: string;
    nameStartswith?: string;
    ordering?: ("-creation_date" | "-length" | "-name" | "creation_date" | "length" | "name")[];
    page?: number;
    pageSize?: number;
    q?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedTagList;
    }>(`/api/v1/tags/${QS.query(QS.explode({
        name,
        name__startswith: nameStartswith,
        page,
        page_size: pageSize,
        q
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
export function getTag(name: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Tag;
    }>(`/api/v1/tags/${encodeURIComponent(name)}/`, {
        ...opts
    });
}
export function previewText(textPreviewRequest: TextPreviewRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: TextPreview;
    } | {
        status: 400;
        data: ErrorDetail;
    }>("/api/v1/text-preview/", oazapfts.json({
        ...opts,
        method: "POST",
        body: textPreviewRequest
    }));
}
/**
 * A simple ViewSet for viewing and editing accounts.
 */
export function getTracks({ album, artist, channel, hidden, id, includeChannels, library, license, mbid, ordering, page, pageSize, playable, q, related, scope, tag, title, titleIcontains, titleIexact, titleStartswith }: {
    album?: number;
    artist?: string;
    channel?: string;
    hidden?: boolean;
    id?: number[];
    includeChannels?: boolean;
    library?: string;
    license?: string;
    mbid?: string;
    ordering?: ("-album__release_date" | "-album__title" | "-artist__modification_date" | "-artist__name" | "-creation_date" | "-disc_number" | "-position" | "-random" | "-related" | "-size" | "-title" | "album__release_date" | "album__title" | "artist__modification_date" | "artist__name" | "creation_date" | "disc_number" | "position" | "random" | "related" | "size" | "title")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
    title?: string;
    titleIcontains?: string;
    titleIexact?: string;
    titleStartswith?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedTrackList;
    }>(`/api/v1/tracks/${QS.query(QS.explode({
        album,
        artist,
        channel,
        hidden,
        id,
        include_channels: includeChannels,
        library,
        license,
        mbid,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag,
        title,
        title__icontains: titleIcontains,
        title__iexact: titleIexact,
        title__startswith: titleStartswith
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
/**
 * A simple ViewSet for viewing and editing accounts.
 */
export function getTrack(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Track;
    }>(`/api/v1/tracks/${encodeURIComponent(id)}/`, {
        ...opts
    });
}
/**
 * A simple ViewSet for viewing and editing accounts.
 */
export function deleteTrack(id: number, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/tracks/${encodeURIComponent(id)}/`, {
        ...opts,
        method: "DELETE"
    });
}
/**
 * A simple ViewSet for viewing and editing accounts.
 */
export function getTrackFetches(id: number, { album, artist, channel, hidden, includeChannels, library, license, mbid, ordering, page, pageSize, playable, q, related, scope, tag, title, titleIcontains, titleIexact, titleStartswith }: {
    album?: number;
    artist?: string;
    channel?: string;
    hidden?: boolean;
    includeChannels?: boolean;
    library?: string;
    license?: string;
    mbid?: string;
    ordering?: ("-album__release_date" | "-album__title" | "-artist__modification_date" | "-artist__name" | "-creation_date" | "-disc_number" | "-position" | "-random" | "-related" | "-size" | "-title" | "album__release_date" | "album__title" | "artist__modification_date" | "artist__name" | "creation_date" | "disc_number" | "position" | "random" | "related" | "size" | "title")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
    title?: string;
    titleIcontains?: string;
    titleIexact?: string;
    titleStartswith?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedFetchList;
    }>(`/api/v1/tracks/${encodeURIComponent(id)}/fetches/${QS.query(QS.explode({
        album,
        artist,
        channel,
        hidden,
        include_channels: includeChannels,
        library,
        license,
        mbid,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag,
        title,
        title__icontains: titleIcontains,
        title__iexact: titleIexact,
        title__startswith: titleStartswith
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
/**
 * A simple ViewSet for viewing and editing accounts.
 */
export function createTrackFetch(id: number, trackRequest: TrackRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: Fetch;
    }>(`/api/v1/tracks/${encodeURIComponent(id)}/fetches/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: trackRequest
    }));
}
/**
 * A simple ViewSet for viewing and editing accounts.
 */
export function getTrackLibraries(id: number, { album, artist, channel, hidden, includeChannels, library, license, mbid, ordering, page, pageSize, playable, q, related, scope, tag, title, titleIcontains, titleIexact, titleStartswith }: {
    album?: number;
    artist?: string;
    channel?: string;
    hidden?: boolean;
    includeChannels?: boolean;
    library?: string;
    license?: string;
    mbid?: string;
    ordering?: ("-album__release_date" | "-album__title" | "-artist__modification_date" | "-artist__name" | "-creation_date" | "-disc_number" | "-position" | "-random" | "-related" | "-size" | "-title" | "album__release_date" | "album__title" | "artist__modification_date" | "artist__name" | "creation_date" | "disc_number" | "position" | "random" | "related" | "size" | "title")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
    title?: string;
    titleIcontains?: string;
    titleIexact?: string;
    titleStartswith?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedLibraryList;
    }>(`/api/v1/tracks/${encodeURIComponent(id)}/libraries/${QS.query(QS.explode({
        album,
        artist,
        channel,
        hidden,
        include_channels: includeChannels,
        library,
        license,
        mbid,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag,
        title,
        title__icontains: titleIcontains,
        title__iexact: titleIexact,
        title__startswith: titleStartswith
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
/**
 * A simple ViewSet for viewing and editing accounts.
 */
export function getTrackMutations(id: number, { album, artist, channel, hidden, includeChannels, library, license, mbid, ordering, page, pageSize, playable, q, related, scope, tag, title, titleIcontains, titleIexact, titleStartswith }: {
    album?: number;
    artist?: string;
    channel?: string;
    hidden?: boolean;
    includeChannels?: boolean;
    library?: string;
    license?: string;
    mbid?: string;
    ordering?: ("-album__release_date" | "-album__title" | "-artist__modification_date" | "-artist__name" | "-creation_date" | "-disc_number" | "-position" | "-random" | "-related" | "-size" | "-title" | "album__release_date" | "album__title" | "artist__modification_date" | "artist__name" | "creation_date" | "disc_number" | "position" | "random" | "related" | "size" | "title")[];
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    related?: string;
    scope?: string;
    tag?: string[];
    title?: string;
    titleIcontains?: string;
    titleIexact?: string;
    titleStartswith?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedApiMutationList;
    }>(`/api/v1/tracks/${encodeURIComponent(id)}/mutations/${QS.query(QS.explode({
        album,
        artist,
        channel,
        hidden,
        include_channels: includeChannels,
        library,
        license,
        mbid,
        page,
        page_size: pageSize,
        playable,
        q,
        related,
        scope,
        tag,
        title,
        title__icontains: titleIcontains,
        title__iexact: titleIexact,
        title__startswith: titleStartswith
    }), QS.form({
        ordering
    }))}`, {
        ...opts
    });
}
/**
 * A simple ViewSet for viewing and editing accounts.
 */
export function createTrackMutation(id: number, trackRequest: TrackRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: ApiMutation;
    }>(`/api/v1/tracks/${encodeURIComponent(id)}/mutations/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: trackRequest
    }));
}
export function getUploads({ albumArtist, channel, importReference, importStatus, includeChannels, library, mimetype, ordering, page, pageSize, playable, q, scope, track, trackArtist }: {
    albumArtist?: string;
    channel?: string;
    importReference?: string;
    importStatus?: ("draft" | "errored" | "finished" | "pending" | "skipped")[];
    includeChannels?: boolean;
    library?: string;
    mimetype?: string;
    ordering?: string;
    page?: number;
    pageSize?: number;
    playable?: boolean;
    q?: string;
    scope?: string;
    track?: string;
    trackArtist?: string;
} = {}, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: PaginatedUploadForOwnerList;
    }>(`/api/v1/uploads/${QS.query(QS.explode({
        album_artist: albumArtist,
        channel,
        import_reference: importReference,
        import_status: importStatus,
        include_channels: includeChannels,
        library,
        mimetype,
        ordering,
        page,
        page_size: pageSize,
        playable,
        q,
        scope,
        track,
        track_artist: trackArtist
    }))}`, {
        ...opts
    });
}
export function createUpload(uploadForOwnerRequest: UploadForOwnerRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 201;
        data: UploadForOwner;
    }>("/api/v1/uploads/", oazapfts.json({
        ...opts,
        method: "POST",
        body: uploadForOwnerRequest
    }));
}
export function getUpload(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UploadForOwner;
    }>(`/api/v1/uploads/${encodeURIComponent(uuid)}/`, {
        ...opts
    });
}
export function updateUpload(uuid: string, uploadForOwnerRequest: UploadForOwnerRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UploadForOwner;
    }>(`/api/v1/uploads/${encodeURIComponent(uuid)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: uploadForOwnerRequest
    }));
}
export function partialUpdateUpload(uuid: string, patchedUploadForOwnerRequest?: PatchedUploadForOwnerRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UploadForOwner;
    }>(`/api/v1/uploads/${encodeURIComponent(uuid)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedUploadForOwnerRequest
    }));
}
export function deleteUpload(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/uploads/${encodeURIComponent(uuid)}/`, {
        ...opts,
        method: "DELETE"
    });
}
export function getUploadMetadata(uuid: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: TrackMetadata;
    }>(`/api/v1/uploads/${encodeURIComponent(uuid)}/audio-file-metadata/`, {
        ...opts
    });
}
/**
 * str(object='') -> str
 * str(bytes_or_buffer[, encoding[, errors]]) -> str
 *
 * Create a new string object from the given object. If encoding or
 * errors is specified, then the object must expose a data buffer
 * that will be decoded using the given encoding and error handler.
 * Otherwise, returns the result of object.__str__() (if defined)
 * or repr(object).
 * encoding defaults to sys.getdefaultencoding().
 * errors defaults to 'strict'.
 */
export function createUploadAction(uploadForOwnerRequest: UploadForOwnerRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UploadForOwner;
    }>("/api/v1/uploads/action/", oazapfts.json({
        ...opts,
        method: "POST",
        body: uploadForOwnerRequest
    }));
}
export function updateUser(username: string, userWriteRequest: UserWriteRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UserWrite;
    }>(`/api/v1/users/${encodeURIComponent(username)}/`, oazapfts.json({
        ...opts,
        method: "PUT",
        body: userWriteRequest
    }));
}
export function partialUpdateUser(username: string, patchedUserWriteRequest?: PatchedUserWriteRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UserWrite;
    }>(`/api/v1/users/${encodeURIComponent(username)}/`, oazapfts.json({
        ...opts,
        method: "PATCH",
        body: patchedUserWriteRequest
    }));
}
export function getUserSubsonicToken(username: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UserWrite;
    }>(`/api/v1/users/${encodeURIComponent(username)}/subsonic-token/`, {
        ...opts
    });
}
export function createUserSubsonicToken(username: string, userWriteRequest: UserWriteRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UserWrite;
    }>(`/api/v1/users/${encodeURIComponent(username)}/subsonic-token/`, oazapfts.json({
        ...opts,
        method: "POST",
        body: userWriteRequest
    }));
}
export function deleteUserSubsonicToken(username: string, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText(`/api/v1/users/${encodeURIComponent(username)}/subsonic-token/`, {
        ...opts,
        method: "DELETE"
    });
}
export function changeEmail(userWriteRequest: UserWriteRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText("/api/v1/users/change-email/", oazapfts.json({
        ...opts,
        method: "POST",
        body: userWriteRequest
    }));
}
/**
 * Return information about the current user or delete it
 */
export function getAuthenticatedUser(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UserWrite;
    }>("/api/v1/users/me/", {
        ...opts
    });
}
/**
 * Return information about the current user or delete it
 */
export function deleteAuthenticatedUser(opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchText("/api/v1/users/me/", {
        ...opts,
        method: "DELETE"
    });
}
/**
 * Return information about the current user or delete it
 */
export function updateSettings(userWriteRequest: UserWriteRequest, opts?: Oazapfts.RequestOpts) {
    return oazapfts.fetchJson<{
        status: 200;
        data: UserWrite;
    }>("/api/v1/users/settings/", oazapfts.json({
        ...opts,
        method: "POST",
        body: userWriteRequest
    }));
}
