import { watchEffect, type Plugin } from 'vue'

import { store } from '../store'
import { defaults } from '../api'

export interface VueAPIOptions {
  instanceUrl: 'auto' | string
}

export const createVueAPI = (vuePluginOptions: Partial<VueAPIOptions> = {}): Plugin => ({
  install (_app) {
    const options: VueAPIOptions = {
      instanceUrl: 'auto',
      ...vuePluginOptions
    }

    // Set instance url
    if (options.instanceUrl === 'auto') {
      watchEffect(() => {
        defaults.baseUrl = store.instanceUrl
      })
    } else {
      defaults.baseUrl = options.instanceUrl
    }
  }
})
