import { type Plugin } from 'vuex'

import { store } from '../store'

export interface VuexAPIOptions {
  stateKey: 'instanceUrl' | string
  mutation: 'instance/instanceUrl' | string
}

export const createVuexAPI = (vuexPluginOptions: Partial<VuexAPIOptions> = {}): Plugin<any> => (vuexStore) => {
  const options: VuexAPIOptions = {
    stateKey: 'instanceUrl',
    mutation: 'instance/instanceUrl',
    ...vuexPluginOptions
  }

  store.vuexPluginRegistered = true
  vuexStore.subscribe((mutation, state) => {
    if (mutation.type === options.mutation) {
      store.instanceUrl = state[options.stateKey]
    }
  })
}
